/*****************************************************
CodeWizardAVR V1.24.4 Standard
Version : 1_0
Date    : 07.09.2008
Author  : Knazev I, S                                                                                                                                                                                                                                                                                                             
Comments:  GEIGER Gamma1 dev_1_1
Chip type           : ATmega8
Clock frequency     : 8,000000 MHz
*****************************************************/
#include <stdio.h> 
#include <mega8.h>
#include <delay.h>
#define key1 PINB.1        
#define key2 PINB.4    
#define key3 PINB.2    
#define key4 PINB.3     
//KEY1 V 
//KEY2 <
//KEY3 >
//KEY4 X  
#define beep  PORTC.5
#define light  PORTC.4    
#define sound  PORTC.1
#define b  PORTC.0
eeprom unsigned int zone1=1;    
eeprom unsigned int zone2=1;  
eeprom unsigned int load1=4;  
unsigned int k=0; //counted qants
int sec=0; //timer
int rf=0; //Ed rfon 
int j=0; // between fon
int i=1;  //buttons    < >
int m_buffer=0;  //buffert for k
int memory=1;     // FOR ZONE1
int memory1=2;     // FOR ZONE2
int warn=3;    // STANDART LEVEL  
bit ok=0;       //OK
bit x=0;        //NO
bit auto1=0;        //auto start mode
bit a1=0;      //start OFF
bit a2=0;    // BACKLIGHT OFF
//bit a3=0;    //SOUND REZONATOR  OFF
bit a4=0;    //AUTO RESTART MODE OFF
char lcd_buffer[125]; //LCD BUFFER LEVEL!
const unsigned char kirilTable[64]= {      //FOR RUSS TEXT
0x41, 0xA0, 0x42, 0xA1, 0xE0, 0x45, 0xA3, 0xA4, 0xA5, 0xA6, 0x4B, 0xA7, 0x4D, 0x48, 0x4F, 0xA8, 
0x50, 0x43, 0x54, 0xA9, 0xAA, 0x58, 0xE1, 0xAB, 0xAC, 0xE2, 0xAD, 0xAE, 0xAD, 0xAF, 0xB0, 0xB1, 
0x61, 0xB2, 0xB3, 0xB4, 0xE3, 0x65, 0xB6, 0xB7, 0xB8, 0xB9, 0xBA, 0xBB, 0xBC, 0xBD, 0x6F, 0xBE, 
0x70, 0x63, 0xBF, 0x79, 0xE4, 0x78, 0xE5, 0xC0, 0xC1, 0xE6, 0xC2, 0xC3, 0xC4, 0xC5, 0xC6, 0xC7};
//------------------------------------INTERRUPTS FOR SEC TIMER------------------------------------//
interrupt [TIM1_COMPA] void timer1_comp_isr(void)
{
sec++;
}
// External Interrupt 1 service routine  //PD3-pin #5
interrupt [EXT_INT1] void ext_int1_isr(void)
{
k++;  j++; 
if(j>20){ rf++; j=0;} 
if(rf==warn){ #asm("cli"); i=10; }    
}
//end external
// Alphanumeric LCD Module functions
#asm
   .equ __lcd_port=0x12 ;PORTD
#endasm
#include <lcd.h>
//FOR RUSS TEXT
void dd_lcd(flash unsigned char *texti, unsigned char len ) 
{ unsigned char ii,P; 
for (ii=0;ii<len;ii++) { 
P= texti[ii]; 
if (P > 0x7F) P=kirilTable[texti[ii]-0xC0]; 
lcd_putchar(P); 
delay_ms(10); } 
}
//------------------------------------------Beep func--------------------------------
void my_beep(void) {    //key beep
        beep = 1;
        delay_ms(30);
        beep = 0;}//-------------------end beep--------------------------------------             
   //    ------------------------------------------Beep long--------------------------------
void long_beep(void) {    //key beep
        beep = 1;
        delay_ms(105);
        beep = 0;        
        delay_ms(100);
             beep = 1;
        delay_ms(100);
        beep = 0; 
        delay_ms(600);
        } //----------------------------Warn beep-----------------------------

//---------------------------------------------KEYS FUNC------------------------------------
void my_keys(void){
if(!key1){ok=1;}else{delay_ms(10); ok=0;}    // ok
if(!key4){x=1;}else{delay_ms(10); x=0;}     // x

if(i<8){ if(!key2){i++; my_beep(); delay_ms(980); }}     // >
if(i>2){if(!key3){i--; my_beep(); delay_ms(980);  }}   // <
}
//----------------------------------------------------MAIN PROGRAMM----------------------------------------//
void main(void)
{
warn=load1;     //AUTO load
PORTB=0xFF; //in
DDRB=0x00;
PORTC=0x4C;    //out
DDRC=0x33;
PORTD=0xFF;  //in
DDRD=0x00;

ACSR=0x80;
SFIOR=0x00;
//------------------------------------------FOR TIMER-----------------------------------------------//
OCR1A=4900;      // ---------------FOR QUARZ
TCCR1B=0x0D;
TIMSK=0x10;
//----------------------------------------------------------------------------------------------------//
// External Interrupt(s) initialization
// INT1: On
// INT1 Mode: is rising
GICR|=0x80;
MCUCR=0x0C;
GIFR=0x80;     //is int1 on/else off
//
lcd_init(16);
my_beep();   //--------------------START-----------------LOADS


//-------------------------------------------------------screen seer
lcd_gotoxy(0,0); lcd_putsf("  Gamma1 V_1.1  ");
lcd_gotoxy(0,1); dd_lcd("   <1>    ",16); 
delay_ms(4950);

lcd_clear();
///------------------------------------------------------------
while (1) {
my_keys();   //----------------------START----------------KEYS
 switch (i) { 
case 1: //---------------------------------------------------Start MENU----------------------------------------------------//
#asm("cli"); 
     
beep=0;
//m_buffer=k;
k=0;
j=0;
sec=0; //timer
rf=0; 
b=1; //start bloking generator

lcd_gotoxy(0,0); dd_lcd("  1 ",16); 
lcd_gotoxy(0,1); dd_lcd("  v...   ",16); 
if((!key1)|(!key2)|(!key3)|(!key4)){my_beep();delay_ms(900);  i++;}// any key press 
break;   //STOP1
case 2: //----------------------------------------------MAIN TEST/AUTO MODE--------------------------------------------------//   
my_keys(); 
lcd_gotoxy(3,0); 
sprintf(lcd_buffer,"=%4umkp " "T%2uc"  "Rf=%2u " "Bufer%4u ",k,sec,rf,m_buffer);//  PRINT ON LCD   
lcd_puts(lcd_buffer);  // FROM BUFFER TO LCD
lcd_gotoxy(0,0); dd_lcd("",3); 
//lcd_gotoxy(7,1); dd_lcd("",5);

if((ok)&(a1)){delay_ms(100);  #asm("sei"); b=1; }  //Start 
if(x){#asm("cli");  beep=0; b=0; }  //Stop
if(sec>=60){m_buffer=k; #asm("cli"); a1=0; } // AUTO STOP
if(sec==61){sec=0; k=0; j=0; rf=0; } //restart
if((sec==60)&(auto1)){sec=0; k=0; j=0; rf=0; #asm("sei"); a1=1;} //auto restart mode:2
if((sec==59)&(!auto1)){delay_ms(350); long_beep();} //only test beep
if(ok){a1=1;}
if(x){a1=0;}

if(k==1600){delay_us(1); sec=0; k=0; j=0; rf=0; beep=0;}   //max radiation
//if(b){long_beep(); delay_us(1); beep=1; b=0;} // restart long beep
break;   
case 3:  //-------------------------------------------AUTO RESTART MODE---------------------//
my_keys();
lcd_gotoxy(0,0); dd_lcd("",5); 
lcd_gotoxy(0,1); dd_lcd(" 1-  2- ",16);               
if(ok){a4=0; auto1=0; }    
if(x){a4=1; auto1=1; }

if(sec>=60){#asm("cli"); m_buffer=k; }  //anti kosac
//lcd_gotoxy(7,0); lcd_putsf("          ");
if(a4){   lcd_gotoxy(5,0); lcd_putsf("2          ");}   
if(!a4){  lcd_gotoxy(5,0); lcd_putsf("1          ");}  

break;   
case 4: //--------------------------------------------EEPROM MEMORY LOAD/SAVE-------------ZONE1------------//
my_keys();
lcd_gotoxy(4,0); 
sprintf(lcd_buffer,"1=%4umkp   ",memory);//   TO LCD
lcd_puts(lcd_buffer);
lcd_gotoxy(0,0); dd_lcd("" ,4);  
lcd_gotoxy(0,1); dd_lcd(" <> " ,16);  
//delay_ms(1); // need wait on timers
if(sec>=60){#asm("cli"); m_buffer=k; }  //anti kosac
if((ok)&(k>=5)){  zone1=m_buffer; my_beep(); delay_ms(900);} //save only quant>10  
if(x){  memory=zone1;my_beep(); delay_ms(900);}  //load

break;  
case 5: //--------------------------------------------EEPROM MEMORY LOAD/SAVE-------------ZONE2------------//
my_keys();
lcd_gotoxy(4,0); 
sprintf(lcd_buffer,"2=%4umkp   ",memory1);//   
lcd_puts(lcd_buffer);
lcd_gotoxy(0,0); dd_lcd("" ,4);  
lcd_gotoxy(0,1); dd_lcd(" <> " ,16);  
//delay_ms(1); // need wait on timers
if(sec>=60){#asm("cli"); m_buffer=k; }  //anti kosac
if((ok)&(k>=5)){  zone2=k; my_beep(); delay_ms(900);} //save only quant>10  
if(x){  memory1=zone2; my_beep(); delay_ms(900);}  //load

break;  
case 6: //-------------------------------------BACKLIGHT ON/OFF----------------------------------------//  
my_keys();
lcd_gotoxy(0,0); dd_lcd("  " ,11);  
lcd_gotoxy(0,1); dd_lcd("v  </>  x" ,16);             
if(ok){a2=1; PORTC.4=1;}    
if(x){a2=0; PORTC.4=0;}
//delay_ms(1); 
if(sec>=60){#asm("cli"); m_buffer=k; }  //anti kosac
if(a2){   lcd_gotoxy(11,0); dd_lcd("  ",5); }   
if(!a2){  lcd_gotoxy(11,0); dd_lcd(" ",5);}    

break;      
//case 7:  //-------------------------------------------SOUND REZONATOR  ON/OFF---------------------//
//my_keys();
//lcd_gotoxy(0,0); dd_lcd("       " ,11);  
//lcd_gotoxy(0,1); dd_lcd("v   /   x" ,16);            
//if(ok){a3=1; PORTC.1=1;}    
//if(x){a3=0; PORTC.1=0;}
//delay_ms(1); 
//if(sec>=60){#asm("cli"); m_buffer=k; }  //anti kosac
//if(a3){   lcd_gotoxy(11,0); dd_lcd("  ",5); }   
//if(!a3){  lcd_gotoxy(11,0); dd_lcd(" ",5);}    

//if(j==20){delay_us(1); rf++; j=0;}   //  FOR ID RADIATION FON ID IS 15-25~=20;
//if(k>warn){delay_us(1); #asm("cli"); i=11; }   //to ALARM radiation
//break;      
case 7:  //---------------------------------WARNING LEVEL------------MODE +/- --------------------------// 
my_keys();
lcd_gotoxy(7,0); 
sprintf(lcd_buffer,"=%3u ",warn);//   
lcd_puts(lcd_buffer);
lcd_gotoxy(0,0); 
dd_lcd("",7);    
lcd_gotoxy(0,1); dd_lcd("+ <   > -",16);    
lcd_gotoxy(12,0); dd_lcd(" ",4);    
if(sec>=60){#asm("cli"); m_buffer=k; }  //anti kosac
if(warn<400){if(!key1){warn++;   load1=warn; delay_ms(380);   }}
if(warn>2){if(!key4){warn--;  load1=warn;  delay_ms(380);  }}  

break;
case 8:  //-------------------POWER--DOWN--MODE --------------------------// 
//#asm("cli");
my_keys();
sec=0; //for 1 main menu
lcd_gotoxy(0,0); dd_lcd("     ",16);   
lcd_gotoxy(0,1); dd_lcd("    <<   ",16);  
if(!key1){delay_ms(90); my_beep(); rf=0; j=0;    i=9;}// go to case9

break;
case 9:  //-------------------POWER--DOWN--ON--------------------------//
#asm("cli"); 
lcd_clear(); 
auto1=0;        //auto off
a1=0;      //start OFF
a2=0;    // BACKLIGHT OFF
//a3=0;    //SOUND REZONATOR  OFF
a4=0;    //AUTO RESTART MODE OFF
//sound=0;   //off
light=0;     //off
#asm("sei");  //Start 
if(!key4){#asm("cli"); k=0; j=0; beep=0; sec=0; rf=0; i=8;}  //Stop   mode end EXIT
if(sec==60){sec=0; k=0; j=0; rf=0; } //auto restart mode:2

if((sec==5)|(sec==15)|(sec==25)|(sec==35)|(sec==45)|(sec==55)){ b=0;}// off bloking
if((sec==0)|(sec==10)|(sec==20)|(sec==30)|(sec==40)|(sec==50)|(sec==59)){ b=1;}//on bloking
// to lcd markers  (is scan)
if((sec==10)|(sec==20)|(sec==30)|(sec==40)|(sec==50)|(sec==59)){
delay_ms(160);   
lcd_gotoxy(0,0); lcd_putsf("");
lcd_gotoxy(0,1); dd_lcd("....",16);    
delay_ms(160);  
lcd_gotoxy(1,0); lcd_putsf(""); 
delay_ms(160);  
lcd_gotoxy(2,0); lcd_putsf(""); 
delay_ms(160);  
lcd_gotoxy(3,0); lcd_putsf(""); 
delay_ms(160);  
lcd_gotoxy(4,0); lcd_putsf(""); 
delay_ms(160);  
lcd_gotoxy(5,0); lcd_putsf(""); 
delay_ms(160);  
lcd_gotoxy(6,0); lcd_putsf(""); 
delay_ms(160);  
lcd_gotoxy(7,0); lcd_putsf(""); 
delay_ms(160);  
lcd_gotoxy(8,0); lcd_putsf(""); 
delay_ms(160);  
lcd_gotoxy(9,0); lcd_putsf(""); 
delay_ms(160);  
lcd_gotoxy(10,0); lcd_putsf(""); 
delay_ms(160);  
lcd_gotoxy(11,0); lcd_putsf(""); 
delay_ms(160);  
lcd_gotoxy(12,0); lcd_putsf(""); 
delay_ms(160);  
lcd_gotoxy(13,0); lcd_putsf(""); 
delay_ms(160);  
lcd_gotoxy(14,0); lcd_putsf(""); 
delay_ms(160);}  
break;
case 10:  //-------------------Alarm case --------------------------// 
//my_keys();
sec=0; //for 1 main menu
beep=1; 
lcd_gotoxy(0,0); dd_lcd("  ",16);   
lcd_gotoxy(0,1); dd_lcd("!      ",16);  
if((!key1)|(!key2)|(!key3)|(!key4)){delay_ms(90); my_beep(); beep=0; i=1;}// go to case1
delay_ms(200);
beep=0;
break;

}
 };        
 }