
;CodeVisionAVR C Compiler V2.03.3 Evaluation
;(C) Copyright 1998-2008 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type              : ATmega8
;Program type           : Application
;Clock frequency        : 2,000000 MHz
;Memory model           : Small
;Optimize for           : Size
;(s)printf features     : int, width
;(s)scanf features      : int, width
;External RAM size      : 0
;Data Stack size        : 256 byte(s)
;Heap size              : 0 byte(s)
;Promote char to int    : Yes
;char is unsigned       : Yes
;global const stored in FLASH  : No
;8 bit enums            : Yes
;Enhanced core instructions    : On
;Smart register allocation : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega8
	#pragma AVRPART MEMORY PROG_FLASH 8192
	#pragma AVRPART MEMORY EEPROM 512
	#pragma AVRPART MEMORY INT_SRAM SIZE 1024
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ANDI R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ORI  R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	LDI  R30,0
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	LDI  R22,BYTE3(2*@0+@1)
	LDI  R23,BYTE4(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+@2)
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+@3)
	LDI  R@1,HIGH(@2+@3)
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+@3)
	LDI  R@1,HIGH(@2*2+@3)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+@2
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+@3
	LDS  R@1,@2+@3+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	RCALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	RCALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	RCALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+@1,R0
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	RCALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	RCALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	RCALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF _k=R4
	.DEF _sec=R6
	.DEF _rf=R8
	.DEF _j=R10
	.DEF _i=R12

	.CSEG
	.ORG 0x00

;INTERRUPT VECTORS
	RJMP __RESET
	RJMP 0x00
	RJMP _ext_int1_isr
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP _timer1_comp_isr
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00

_tbl10_G100:
	.DB  0x10,0x27,0xE8,0x3,0x64,0x0,0xA,0x0
	.DB  0x1,0x0
_tbl16_G100:
	.DB  0x0,0x10,0x0,0x1,0x10,0x0,0x1,0x0

_0x3:
	.DB  0x1
_0x4:
	.DB  0x2
_0x5:
	.DB  0x3
_0x6:
	.DB  0x41,0xA0,0x42,0xA1,0xE0,0x45,0xA3,0xA4
	.DB  0xA5,0xA6,0x4B,0xA7,0x4D,0x48,0x4F,0xA8
	.DB  0x50,0x43,0x54,0xA9,0xAA,0x58,0xE1,0xAB
	.DB  0xAC,0xE2,0xAD,0xAE,0xAD,0xAF,0xB0,0xB1
	.DB  0x61,0xB2,0xB3,0xB4,0xE3,0x65,0xB6,0xB7
	.DB  0xB8,0xB9,0xBA,0xBB,0xBC,0xBD,0x6F,0xBE
	.DB  0x70,0x63,0xBF,0x79,0xE4,0x78,0xE5,0xC0
	.DB  0xC1,0xE6,0xC2,0xC3,0xC4,0xC5,0xC6,0xC7
_0x79:
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x1,0x0
_0x0:
	.DB  0x20,0x20,0x47,0x61,0x6D,0x6D,0x61,0x31
	.DB  0x20,0x56,0x5F,0x31,0x2E,0x31,0x20,0x20
	.DB  0x0,0x20,0x20,0xC2,0xE5,0xF0,0xF1,0xE8
	.DB  0xFF,0x20,0x3C,0x31,0x3E,0x20,0x20,0x20
	.DB  0x20,0x0,0xC4,0xEE,0xE7,0xE8,0xEC,0xE5
	.DB  0xF2,0xF0,0x20,0x20,0xC3,0xE0,0xEC,0xEC
	.DB  0xE0,0x31,0x20,0x0,0xCD,0xE0,0xE6,0xEC
	.DB  0xE8,0xF2,0xE5,0x20,0x20,0x76,0x2E,0x2E
	.DB  0x2E,0x20,0x20,0x20,0x0,0x3D,0x25,0x34
	.DB  0x75,0x6D,0x6B,0x70,0x20,0x54,0x25,0x32
	.DB  0x75,0x63,0x52,0x66,0x3D,0x25,0x32,0x75
	.DB  0x20,0x42,0x75,0x66,0x65,0x72,0x25,0x34
	.DB  0x75,0x20,0x0,0xD4,0xEE,0xED,0x0,0xD0
	.DB  0xE5,0xE6,0xE8,0xEC,0x0,0x20,0x31,0x2D
	.DB  0xD2,0xE5,0xF1,0xF2,0x20,0x20,0x32,0x2D
	.DB  0xD6,0xE8,0xEA,0xEB,0x20,0x0,0x32,0x20
	.DB  0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20
	.DB  0x20,0x0,0x31,0x20,0x20,0x20,0x20,0x20
	.DB  0x20,0x20,0x20,0x20,0x20,0x0,0x31,0x3D
	.DB  0x25,0x34,0x75,0x6D,0x6B,0x70,0x20,0x20
	.DB  0x20,0x0,0xC7,0xEE,0xED,0xE0,0x0,0xC7
	.DB  0xE0,0xEF,0xE8,0xF1,0xFC,0x20,0x3C,0x3E
	.DB  0x20,0xD7,0xF2,0xE5,0xED,0xE8,0xE5,0x0
	.DB  0x32,0x3D,0x25,0x34,0x75,0x6D,0x6B,0x70
	.DB  0x20,0x20,0x20,0x0,0xCF,0xEE,0xE4,0xF1
	.DB  0xE2,0xE5,0xF2,0xEA,0xE0,0x20,0x20,0x0
	.DB  0x76,0x20,0x20,0x3C,0xE2,0xEA,0xEB,0x2F
	.DB  0xE2,0xFB,0xEA,0xEB,0x3E,0x20,0x20,0x78
	.DB  0x0,0xE2,0xEA,0xEB,0x20,0x20,0x0,0xE2
	.DB  0xFB,0xEA,0xEB,0x20,0x0,0x3D,0x25,0x33
	.DB  0x75,0x20,0x0,0xD2,0xF0,0xE5,0xE2,0xEE
	.DB  0xE3,0xE0,0x0,0x2B,0x20,0x3C,0x20,0xD3
	.DB  0xF0,0xEE,0xE2,0xE5,0xED,0xFC,0x20,0x20
	.DB  0x3E,0x20,0x2D,0x0,0xC5,0xD0,0xD4,0x20
	.DB  0x0,0xD1,0xEF,0xFF,0xF9,0xE8,0xE9,0x20
	.DB  0xF0,0xE5,0xE6,0xE8,0xEC,0x20,0x20,0x20
	.DB  0x20,0x0,0xE2,0xEA,0xEB,0x20,0x20,0x20
	.DB  0x20,0x3C,0x3C,0x20,0x20,0x20,0xE2,0xFB
	.DB  0xEA,0xEB,0x0,0xFF,0x0,0xD1,0xEA,0xE0
	.DB  0xED,0xE8,0xF0,0xEE,0xE2,0xE0,0xED,0xE8
	.DB  0xE5,0x2E,0x2E,0x2E,0x2E,0x0,0xCE,0xEF
	.DB  0xE0,0xF1,0xED,0xFB,0xE9,0x20,0xF3,0xF0
	.DB  0xEE,0xE2,0xE5,0xED,0xFC,0x20,0x0,0xF0
	.DB  0xE0,0xE4,0xE8,0xE0,0xF6,0xE8,0xE8,0x21
	.DB  0x20,0x20,0x20,0x20,0x20,0x20,0xF5,0x0
_0x2020003:
	.DB  0x80,0xC0

__GLOBAL_INI_TBL:
	.DW  0x01
	.DW  _memory
	.DW  _0x3*2

	.DW  0x01
	.DW  _memory1
	.DW  _0x4*2

	.DW  0x01
	.DW  _warn
	.DW  _0x5*2

	.DW  0x40
	.DW  _kirilTable
	.DW  _0x6*2

	.DW  0x0A
	.DW  0x04
	.DW  _0x79*2

	.DW  0x02
	.DW  __base_y_G101
	.DW  _0x2020003*2

_0xFFFFFFFF:
	.DW  0

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x400)
	LDI  R25,HIGH(0x400)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x45F)
	OUT  SPL,R30
	LDI  R30,HIGH(0x45F)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x160)
	LDI  R29,HIGH(0x160)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x160

	.CSEG
;/*****************************************************
;CodeWizardAVR V1.24.4 Standard
;Version : 1_0
;Date    : 07.09.2008
;Author  : Knazev I, S
;Comments:  GEIGER Gamma1 dev_1_1
;Chip type           : ATmega8
;Clock frequency     : 8,000000 MHz
;*****************************************************/
;#include <stdio.h>
;#include <mega8.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
;#include <delay.h>
;#define key1 PINB.1
;#define key2 PINB.4
;#define key3 PINB.2
;#define key4 PINB.3
;//KEY1 V
;//KEY2 <
;//KEY3 >
;//KEY4 X
;#define beep  PORTC.5
;#define light  PORTC.4
;#define sound  PORTC.1
;#define b  PORTC.0
;eeprom unsigned int zone1=1;
;eeprom unsigned int zone2=1;
;eeprom unsigned int load1=4;
;unsigned int k=0; //counted qants
;int sec=0; //timer
;int rf=0; //Ed rfon
;int j=0; // between fon
;int i=1;  //buttons    < >
;int m_buffer=0;  //buffert for k
;int memory=1;     // FOR ZONE1

	.DSEG
;int memory1=2;     // FOR ZONE2
;int warn=3;    // STANDART LEVEL  
;bit ok=0;       //OK
;bit x=0;        //NO
;bit auto1=0;        //auto start mode
;bit a1=0;      //start OFF
;bit a2=0;    // BACKLIGHT OFF
;//bit a3=0;    //SOUND REZONATOR  OFF
;bit a4=0;    //AUTO RESTART MODE OFF
;char lcd_buffer[125]; //LCD BUFFER LEVEL!
;const unsigned char kirilTable[64]= {      //FOR RUSS TEXT
;0x41, 0xA0, 0x42, 0xA1, 0xE0, 0x45, 0xA3, 0xA4, 0xA5, 0xA6, 0x4B, 0xA7, 0x4D, 0x48, 0x4F, 0xA8,
;0x50, 0x43, 0x54, 0xA9, 0xAA, 0x58, 0xE1, 0xAB, 0xAC, 0xE2, 0xAD, 0xAE, 0xAD, 0xAF, 0xB0, 0xB1,
;0x61, 0xB2, 0xB3, 0xB4, 0xE3, 0x65, 0xB6, 0xB7, 0xB8, 0xB9, 0xBA, 0xBB, 0xBC, 0xBD, 0x6F, 0xBE,
;0x70, 0x63, 0xBF, 0x79, 0xE4, 0x78, 0xE5, 0xC0, 0xC1, 0xE6, 0xC2, 0xC3, 0xC4, 0xC5, 0xC6, 0xC7};
;//------------------------------------INTERRUPTS FOR SEC TIMER------------------------------------//
;interrupt [TIM1_COMPA] void timer1_comp_isr(void)
; 0000 0034 {

	.CSEG
_timer1_comp_isr:
	RCALL SUBOPT_0x0
; 0000 0035 sec++;
	MOVW R30,R6
	ADIW R30,1
	MOVW R6,R30
; 0000 0036 }
	RJMP _0x78
;// External Interrupt 1 service routine  //PD3-pin #5
;interrupt [EXT_INT1] void ext_int1_isr(void)
; 0000 0039 {
_ext_int1_isr:
	RCALL SUBOPT_0x0
; 0000 003A k++;  j++;
	MOVW R30,R4
	ADIW R30,1
	MOVW R4,R30
	MOVW R30,R10
	ADIW R30,1
	MOVW R10,R30
; 0000 003B if(j>20){ rf++; j=0;}
	LDI  R30,LOW(20)
	LDI  R31,HIGH(20)
	CP   R30,R10
	CPC  R31,R11
	BRGE _0x7
	MOVW R30,R8
	ADIW R30,1
	MOVW R8,R30
	RCALL SUBOPT_0x1
; 0000 003C if(rf==warn){ #asm("cli"); i=10; }
_0x7:
	RCALL SUBOPT_0x2
	CP   R30,R8
	CPC  R31,R9
	BRNE _0x8
	cli
	RCALL SUBOPT_0x3
	MOVW R12,R30
; 0000 003D }
_0x8:
_0x78:
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	RETI
;//end external
;// Alphanumeric LCD Module functions
;#asm
   .equ __lcd_port=0x12 ;PORTD
; 0000 0042 #endasm
;#include <lcd.h>
;//FOR RUSS TEXT
;void dd_lcd(flash unsigned char *texti, unsigned char len )
; 0000 0046 { unsigned char ii,P;
_dd_lcd:
; 0000 0047 for (ii=0;ii<len;ii++) {
	RCALL __SAVELOCR2
;	*texti -> Y+3
;	len -> Y+2
;	ii -> R17
;	P -> R16
	LDI  R17,LOW(0)
_0xA:
	LDD  R30,Y+2
	CP   R17,R30
	BRSH _0xB
; 0000 0048 P= texti[ii];
	RCALL SUBOPT_0x4
	LPM  R16,Z
; 0000 0049 if (P > 0x7F) P=kirilTable[texti[ii]-0xC0];
	CPI  R16,128
	BRLO _0xC
	RCALL SUBOPT_0x4
	LPM  R30,Z
	RCALL SUBOPT_0x5
	SUBI R30,LOW(192)
	SBCI R31,HIGH(192)
	SUBI R30,LOW(-_kirilTable)
	SBCI R31,HIGH(-_kirilTable)
	LD   R16,Z
; 0000 004A lcd_putchar(P);
_0xC:
	ST   -Y,R16
	RCALL _lcd_putchar
; 0000 004B delay_ms(10); }
	RCALL SUBOPT_0x6
	SUBI R17,-1
	RJMP _0xA
_0xB:
; 0000 004C }
	RCALL __LOADLOCR2
	ADIW R28,5
	RET
;//------------------------------------------Beep func--------------------------------
;void my_beep(void) {    //key beep
; 0000 004E void my_beep(void) {
_my_beep:
; 0000 004F         beep = 1;
	SBI  0x15,5
; 0000 0050         delay_ms(30);
	LDI  R30,LOW(30)
	LDI  R31,HIGH(30)
	RCALL SUBOPT_0x7
; 0000 0051         beep = 0;}//-------------------end beep--------------------------------------
	RET
;   //    ------------------------------------------Beep long--------------------------------
;void long_beep(void) {    //key beep
; 0000 0053 void long_beep(void) {
_long_beep:
; 0000 0054         beep = 1;
	SBI  0x15,5
; 0000 0055         delay_ms(105);
	LDI  R30,LOW(105)
	LDI  R31,HIGH(105)
	RCALL SUBOPT_0x7
; 0000 0056         beep = 0;
; 0000 0057         delay_ms(100);
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	RCALL SUBOPT_0x8
; 0000 0058              beep = 1;
	SBI  0x15,5
; 0000 0059         delay_ms(100);
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	RCALL SUBOPT_0x7
; 0000 005A         beep = 0;
; 0000 005B         delay_ms(600);
	LDI  R30,LOW(600)
	LDI  R31,HIGH(600)
	RCALL SUBOPT_0x8
; 0000 005C         } //----------------------------Warn beep-----------------------------
	RET
;
;//---------------------------------------------KEYS FUNC------------------------------------
;void my_keys(void){
; 0000 005F void my_keys(void){
_my_keys:
; 0000 0060 if(!key1){ok=1;}else{delay_ms(10); ok=0;}    // ok
	SBIC 0x16,1
	RJMP _0x19
	SET
	RJMP _0x76
_0x19:
	RCALL SUBOPT_0x6
	CLT
_0x76:
	BLD  R2,0
; 0000 0061 if(!key4){x=1;}else{delay_ms(10); x=0;}     // x
	SBIC 0x16,3
	RJMP _0x1B
	SET
	RJMP _0x77
_0x1B:
	RCALL SUBOPT_0x6
	CLT
_0x77:
	BLD  R2,1
; 0000 0062 
; 0000 0063 if(i<8){ if(!key2){i++; my_beep(); delay_ms(980); }}     // >
	RCALL SUBOPT_0x9
	CP   R12,R30
	CPC  R13,R31
	BRGE _0x1D
	SBIC 0x16,4
	RJMP _0x1E
	MOVW R30,R12
	ADIW R30,1
	RCALL SUBOPT_0xA
_0x1E:
; 0000 0064 if(i>2){if(!key3){i--; my_beep(); delay_ms(980);  }}   // <
_0x1D:
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	CP   R30,R12
	CPC  R31,R13
	BRGE _0x1F
	SBIC 0x16,2
	RJMP _0x20
	MOVW R30,R12
	SBIW R30,1
	RCALL SUBOPT_0xA
_0x20:
; 0000 0065 }
_0x1F:
	RET
;//----------------------------------------------------MAIN PROGRAMM----------------------------------------//
;void main(void)
; 0000 0068 {
_main:
; 0000 0069 warn=load1;     //AUTO load
	LDI  R26,LOW(_load1)
	LDI  R27,HIGH(_load1)
	RCALL __EEPROMRDW
	STS  _warn,R30
	STS  _warn+1,R31
; 0000 006A PORTB=0xFF; //in
	LDI  R30,LOW(255)
	OUT  0x18,R30
; 0000 006B DDRB=0x00;
	LDI  R30,LOW(0)
	OUT  0x17,R30
; 0000 006C PORTC=0x4C;    //out
	LDI  R30,LOW(76)
	OUT  0x15,R30
; 0000 006D DDRC=0x33;
	LDI  R30,LOW(51)
	OUT  0x14,R30
; 0000 006E PORTD=0xFF;  //in
	LDI  R30,LOW(255)
	OUT  0x12,R30
; 0000 006F DDRD=0x00;
	LDI  R30,LOW(0)
	OUT  0x11,R30
; 0000 0070 
; 0000 0071 ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
; 0000 0072 SFIOR=0x00;
	LDI  R30,LOW(0)
	OUT  0x30,R30
; 0000 0073 //------------------------------------------FOR TIMER-----------------------------------------------//
; 0000 0074 OCR1A=4900;      // ---------------FOR QUARZ
	LDI  R30,LOW(4900)
	LDI  R31,HIGH(4900)
	OUT  0x2A+1,R31
	OUT  0x2A,R30
; 0000 0075 TCCR1B=0x0D;
	LDI  R30,LOW(13)
	OUT  0x2E,R30
; 0000 0076 TIMSK=0x10;
	LDI  R30,LOW(16)
	OUT  0x39,R30
; 0000 0077 //----------------------------------------------------------------------------------------------------//
; 0000 0078 // External Interrupt(s) initialization
; 0000 0079 // INT1: On
; 0000 007A // INT1 Mode: is rising
; 0000 007B GICR|=0x80;
	IN   R30,0x3B
	RCALL SUBOPT_0x5
	ORI  R30,0x80
	OUT  0x3B,R30
; 0000 007C MCUCR=0x0C;
	LDI  R30,LOW(12)
	OUT  0x35,R30
; 0000 007D GIFR=0x80;     //is int1 on/else off
	LDI  R30,LOW(128)
	OUT  0x3A,R30
; 0000 007E //
; 0000 007F lcd_init(16);
	RCALL SUBOPT_0xB
	RCALL _lcd_init
; 0000 0080 my_beep();   //--------------------START-----------------LOADS
	RCALL _my_beep
; 0000 0081 
; 0000 0082 
; 0000 0083 //-------------------------------------------------------screen seer
; 0000 0084 lcd_gotoxy(0,0); lcd_putsf("  Gamma1 V_1.1  ");
	RCALL SUBOPT_0xC
	RCALL SUBOPT_0xC
	RCALL _lcd_gotoxy
	__POINTW1FN _0x0,0
	RCALL SUBOPT_0xD
	RCALL _lcd_putsf
; 0000 0085 lcd_gotoxy(0,1); dd_lcd("   <1>    ",16);
	RCALL SUBOPT_0xC
	RCALL SUBOPT_0xE
	__POINTW1FN _0x0,17
	RCALL SUBOPT_0xF
	RCALL _dd_lcd
; 0000 0086 delay_ms(4950);
	LDI  R30,LOW(4950)
	LDI  R31,HIGH(4950)
	RCALL SUBOPT_0x8
; 0000 0087 
; 0000 0088 lcd_clear();
	RCALL _lcd_clear
; 0000 0089 ///------------------------------------------------------------
; 0000 008A while (1) {
_0x21:
; 0000 008B my_keys();   //----------------------START----------------KEYS
	RCALL _my_keys
; 0000 008C  switch (i) {
	MOVW R30,R12
; 0000 008D case 1: //---------------------------------------------------Start MENU----------------------------------------------------//
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BRNE _0x27
; 0000 008E #asm("cli");
	cli
; 0000 008F 
; 0000 0090 beep=0;
	CBI  0x15,5
; 0000 0091 //m_buffer=k;
; 0000 0092 k=0;
	RCALL SUBOPT_0x10
; 0000 0093 j=0;
; 0000 0094 sec=0; //timer
	RCALL SUBOPT_0x11
; 0000 0095 rf=0;
	RCALL SUBOPT_0x12
; 0000 0096 b=1; //start bloking generator
	SBI  0x15,0
; 0000 0097 
; 0000 0098 lcd_gotoxy(0,0); dd_lcd("  1 ",16);
	RCALL SUBOPT_0xC
	RCALL SUBOPT_0xC
	RCALL _lcd_gotoxy
	__POINTW1FN _0x0,34
	RCALL SUBOPT_0xF
	RCALL SUBOPT_0x13
; 0000 0099 lcd_gotoxy(0,1); dd_lcd("  v...   ",16);
	RCALL SUBOPT_0xE
	__POINTW1FN _0x0,52
	RCALL SUBOPT_0xF
	RCALL SUBOPT_0x14
; 0000 009A if((!key1)|(!key2)|(!key3)|(!key4)){my_beep();delay_ms(900);  i++;}// any key press
	BREQ _0x2C
	RCALL SUBOPT_0x15
	MOVW R30,R12
	ADIW R30,1
	MOVW R12,R30
; 0000 009B break;   //STOP1
_0x2C:
	RJMP _0x26
; 0000 009C case 2: //----------------------------------------------MAIN TEST/AUTO MODE--------------------------------------------------//
_0x27:
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BREQ PC+2
	RJMP _0x2D
; 0000 009D my_keys();
	RCALL _my_keys
; 0000 009E lcd_gotoxy(3,0);
	LDI  R30,LOW(3)
	RCALL SUBOPT_0x16
	RCALL SUBOPT_0x17
; 0000 009F sprintf(lcd_buffer,"=%4umkp " "T%2uc"  "Rf=%2u " "Bufer%4u ",k,sec,rf,m_buffer);//  PRINT ON LCD
	__POINTW1FN _0x0,69
	RCALL SUBOPT_0xD
	MOVW R30,R4
	CLR  R22
	CLR  R23
	RCALL __PUTPARD1
	MOVW R30,R6
	RCALL SUBOPT_0x18
	MOVW R30,R8
	RCALL SUBOPT_0x18
	RCALL SUBOPT_0x19
	RCALL SUBOPT_0x18
	LDI  R24,16
	RCALL _sprintf
	ADIW R28,20
; 0000 00A0 lcd_puts(lcd_buffer);  // FROM BUFFER TO LCD
	RCALL SUBOPT_0x1A
; 0000 00A1 lcd_gotoxy(0,0); dd_lcd("",3);
	RCALL SUBOPT_0xC
	RCALL _lcd_gotoxy
	__POINTW1FN _0x0,99
	RCALL SUBOPT_0xD
	LDI  R30,LOW(3)
	RCALL SUBOPT_0x1B
; 0000 00A2 //lcd_gotoxy(7,1); dd_lcd("",5);
; 0000 00A3 
; 0000 00A4 if((ok)&(a1)){delay_ms(100);  #asm("sei"); b=1; }  //Start
	RCALL SUBOPT_0x1C
	RCALL SUBOPT_0x1D
	LDI  R30,0
	SBRC R2,3
	LDI  R30,1
	RCALL SUBOPT_0x1E
	BREQ _0x2E
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	RCALL SUBOPT_0x8
	sei
	SBI  0x15,0
; 0000 00A5 if(x){#asm("cli");  beep=0; b=0; }  //Stop
_0x2E:
	SBRS R2,1
	RJMP _0x31
	cli
	CBI  0x15,5
	CBI  0x15,0
; 0000 00A6 if(sec>=60){m_buffer=k; #asm("cli"); a1=0; } // AUTO STOP
_0x31:
	RCALL SUBOPT_0x1F
	RCALL SUBOPT_0x20
	BRLT _0x36
	RCALL SUBOPT_0x21
	cli
	CLT
	BLD  R2,3
; 0000 00A7 if(sec==61){sec=0; k=0; j=0; rf=0; } //restart
_0x36:
	LDI  R30,LOW(61)
	LDI  R31,HIGH(61)
	CP   R30,R6
	CPC  R31,R7
	BRNE _0x37
	RCALL SUBOPT_0x22
	RCALL SUBOPT_0x12
; 0000 00A8 if((sec==60)&(auto1)){sec=0; k=0; j=0; rf=0; #asm("sei"); a1=1;} //auto restart mode:2
_0x37:
	MOVW R26,R6
	RCALL SUBOPT_0x1F
	RCALL __EQW12
	RCALL SUBOPT_0x1D
	LDI  R30,0
	SBRC R2,2
	LDI  R30,1
	RCALL SUBOPT_0x1E
	BREQ _0x38
	RCALL SUBOPT_0x22
	RCALL SUBOPT_0x12
	sei
	SET
	BLD  R2,3
; 0000 00A9 if((sec==59)&(!auto1)){delay_ms(350); long_beep();} //only test beep
_0x38:
	RCALL SUBOPT_0x23
	RCALL SUBOPT_0x1D
	LDI  R30,0
	SBRS R2,2
	LDI  R30,1
	RCALL SUBOPT_0x1E
	BREQ _0x39
	LDI  R30,LOW(350)
	LDI  R31,HIGH(350)
	RCALL SUBOPT_0x8
	RCALL _long_beep
; 0000 00AA if(ok){a1=1;}
_0x39:
	SBRS R2,0
	RJMP _0x3A
	SET
	BLD  R2,3
; 0000 00AB if(x){a1=0;}
_0x3A:
	SBRS R2,1
	RJMP _0x3B
	CLT
	BLD  R2,3
; 0000 00AC 
; 0000 00AD if(k==1600){delay_us(1); sec=0; k=0; j=0; rf=0; beep=0;}   //max radiation
_0x3B:
	LDI  R30,LOW(1600)
	LDI  R31,HIGH(1600)
	CP   R30,R4
	CPC  R31,R5
	BRNE _0x3C
	__DELAY_USB 1
	RCALL SUBOPT_0x22
	RCALL SUBOPT_0x12
	CBI  0x15,5
; 0000 00AE //if(b){long_beep(); delay_us(1); beep=1; b=0;} // restart long beep
; 0000 00AF break;
_0x3C:
	RJMP _0x26
; 0000 00B0 case 3:  //-------------------------------------------AUTO RESTART MODE---------------------//
_0x2D:
	CPI  R30,LOW(0x3)
	LDI  R26,HIGH(0x3)
	CPC  R31,R26
	BRNE _0x3F
; 0000 00B1 my_keys();
	RCALL _my_keys
; 0000 00B2 lcd_gotoxy(0,0); dd_lcd("",5);
	RCALL SUBOPT_0xC
	RCALL SUBOPT_0xC
	RCALL _lcd_gotoxy
	__POINTW1FN _0x0,103
	RCALL SUBOPT_0xD
	LDI  R30,LOW(5)
	RCALL SUBOPT_0x24
; 0000 00B3 lcd_gotoxy(0,1); dd_lcd(" 1-  2- ",16);
	RCALL SUBOPT_0xE
	__POINTW1FN _0x0,109
	RCALL SUBOPT_0xF
	RCALL _dd_lcd
; 0000 00B4 if(ok){a4=0; auto1=0; }
	SBRS R2,0
	RJMP _0x40
	CLT
	BLD  R2,5
	BLD  R2,2
; 0000 00B5 if(x){a4=1; auto1=1; }
_0x40:
	SBRS R2,1
	RJMP _0x41
	SET
	BLD  R2,5
	BLD  R2,2
; 0000 00B6 
; 0000 00B7 if(sec>=60){#asm("cli"); m_buffer=k; }  //anti kosac
_0x41:
	RCALL SUBOPT_0x25
	BRLT _0x42
	cli
	RCALL SUBOPT_0x21
; 0000 00B8 //lcd_gotoxy(7,0); lcd_putsf("          ");
; 0000 00B9 if(a4){   lcd_gotoxy(5,0); lcd_putsf("2          ");}
_0x42:
	SBRS R2,5
	RJMP _0x43
	LDI  R30,LOW(5)
	RCALL SUBOPT_0x16
	RCALL _lcd_gotoxy
	__POINTW1FN _0x0,126
	RCALL SUBOPT_0x26
; 0000 00BA if(!a4){  lcd_gotoxy(5,0); lcd_putsf("1          ");}
_0x43:
	SBRC R2,5
	RJMP _0x44
	LDI  R30,LOW(5)
	RCALL SUBOPT_0x16
	RCALL _lcd_gotoxy
	__POINTW1FN _0x0,138
	RCALL SUBOPT_0x26
; 0000 00BB 
; 0000 00BC break;
_0x44:
	RJMP _0x26
; 0000 00BD case 4: //--------------------------------------------EEPROM MEMORY LOAD/SAVE-------------ZONE1------------//
_0x3F:
	CPI  R30,LOW(0x4)
	LDI  R26,HIGH(0x4)
	CPC  R31,R26
	BRNE _0x45
; 0000 00BE my_keys();
	RCALL _my_keys
; 0000 00BF lcd_gotoxy(4,0);
	LDI  R30,LOW(4)
	RCALL SUBOPT_0x16
	RCALL SUBOPT_0x17
; 0000 00C0 sprintf(lcd_buffer,"1=%4umkp   ",memory);//   TO LCD
	__POINTW1FN _0x0,150
	RCALL SUBOPT_0xD
	LDS  R30,_memory
	LDS  R31,_memory+1
	RCALL SUBOPT_0x18
	RCALL SUBOPT_0x27
; 0000 00C1 lcd_puts(lcd_buffer);
; 0000 00C2 lcd_gotoxy(0,0); dd_lcd("" ,4);
	RCALL SUBOPT_0xC
	RCALL SUBOPT_0x28
; 0000 00C3 lcd_gotoxy(0,1); dd_lcd(" <> " ,16);
	RCALL SUBOPT_0xE
	__POINTW1FN _0x0,167
	RCALL SUBOPT_0xF
	RCALL _dd_lcd
; 0000 00C4 //delay_ms(1); // need wait on timers
; 0000 00C5 if(sec>=60){#asm("cli"); m_buffer=k; }  //anti kosac
	RCALL SUBOPT_0x25
	BRLT _0x46
	cli
	RCALL SUBOPT_0x21
; 0000 00C6 if((ok)&(k>=5)){  zone1=m_buffer; my_beep(); delay_ms(900);} //save only quant>10
_0x46:
	RCALL SUBOPT_0x1C
	RCALL SUBOPT_0x29
	BREQ _0x47
	RCALL SUBOPT_0x19
	LDI  R26,LOW(_zone1)
	LDI  R27,HIGH(_zone1)
	RCALL __EEPROMWRW
	RCALL SUBOPT_0x15
; 0000 00C7 if(x){  memory=zone1;my_beep(); delay_ms(900);}  //load
_0x47:
	SBRS R2,1
	RJMP _0x48
	LDI  R26,LOW(_zone1)
	LDI  R27,HIGH(_zone1)
	RCALL __EEPROMRDW
	STS  _memory,R30
	STS  _memory+1,R31
	RCALL SUBOPT_0x15
; 0000 00C8 
; 0000 00C9 break;
_0x48:
	RJMP _0x26
; 0000 00CA case 5: //--------------------------------------------EEPROM MEMORY LOAD/SAVE-------------ZONE2------------//
_0x45:
	CPI  R30,LOW(0x5)
	LDI  R26,HIGH(0x5)
	CPC  R31,R26
	BRNE _0x49
; 0000 00CB my_keys();
	RCALL _my_keys
; 0000 00CC lcd_gotoxy(4,0);
	LDI  R30,LOW(4)
	RCALL SUBOPT_0x16
	RCALL SUBOPT_0x17
; 0000 00CD sprintf(lcd_buffer,"2=%4umkp   ",memory1);//
	__POINTW1FN _0x0,184
	RCALL SUBOPT_0xD
	LDS  R30,_memory1
	LDS  R31,_memory1+1
	RCALL SUBOPT_0x18
	RCALL SUBOPT_0x27
; 0000 00CE lcd_puts(lcd_buffer);
; 0000 00CF lcd_gotoxy(0,0); dd_lcd("" ,4);
	RCALL SUBOPT_0xC
	RCALL SUBOPT_0x28
; 0000 00D0 lcd_gotoxy(0,1); dd_lcd(" <> " ,16);
	RCALL SUBOPT_0xE
	__POINTW1FN _0x0,167
	RCALL SUBOPT_0xF
	RCALL _dd_lcd
; 0000 00D1 //delay_ms(1); // need wait on timers
; 0000 00D2 if(sec>=60){#asm("cli"); m_buffer=k; }  //anti kosac
	RCALL SUBOPT_0x25
	BRLT _0x4A
	cli
	RCALL SUBOPT_0x21
; 0000 00D3 if((ok)&(k>=5)){  zone2=k; my_beep(); delay_ms(900);} //save only quant>10
_0x4A:
	RCALL SUBOPT_0x1C
	RCALL SUBOPT_0x29
	BREQ _0x4B
	MOVW R30,R4
	LDI  R26,LOW(_zone2)
	LDI  R27,HIGH(_zone2)
	RCALL __EEPROMWRW
	RCALL SUBOPT_0x15
; 0000 00D4 if(x){  memory1=zone2; my_beep(); delay_ms(900);}  //load
_0x4B:
	SBRS R2,1
	RJMP _0x4C
	LDI  R26,LOW(_zone2)
	LDI  R27,HIGH(_zone2)
	RCALL __EEPROMRDW
	STS  _memory1,R30
	STS  _memory1+1,R31
	RCALL SUBOPT_0x15
; 0000 00D5 
; 0000 00D6 break;
_0x4C:
	RJMP _0x26
; 0000 00D7 case 6: //-------------------------------------BACKLIGHT ON/OFF----------------------------------------//
_0x49:
	CPI  R30,LOW(0x6)
	LDI  R26,HIGH(0x6)
	CPC  R31,R26
	BRNE _0x4D
; 0000 00D8 my_keys();
	RCALL _my_keys
; 0000 00D9 lcd_gotoxy(0,0); dd_lcd("  " ,11);
	RCALL SUBOPT_0xC
	RCALL SUBOPT_0xC
	RCALL _lcd_gotoxy
	__POINTW1FN _0x0,196
	RCALL SUBOPT_0xD
	LDI  R30,LOW(11)
	RCALL SUBOPT_0x24
; 0000 00DA lcd_gotoxy(0,1); dd_lcd("v  </>  x" ,16);
	RCALL SUBOPT_0xE
	__POINTW1FN _0x0,208
	RCALL SUBOPT_0xF
	RCALL _dd_lcd
; 0000 00DB if(ok){a2=1; PORTC.4=1;}
	SBRS R2,0
	RJMP _0x4E
	SET
	BLD  R2,4
	SBI  0x15,4
; 0000 00DC if(x){a2=0; PORTC.4=0;}
_0x4E:
	SBRS R2,1
	RJMP _0x51
	CLT
	BLD  R2,4
	CBI  0x15,4
; 0000 00DD //delay_ms(1);
; 0000 00DE if(sec>=60){#asm("cli"); m_buffer=k; }  //anti kosac
_0x51:
	RCALL SUBOPT_0x25
	BRLT _0x54
	cli
	RCALL SUBOPT_0x21
; 0000 00DF if(a2){   lcd_gotoxy(11,0); dd_lcd("  ",5); }
_0x54:
	SBRS R2,4
	RJMP _0x55
	LDI  R30,LOW(11)
	RCALL SUBOPT_0x16
	RCALL _lcd_gotoxy
	__POINTW1FN _0x0,225
	RCALL SUBOPT_0xD
	LDI  R30,LOW(5)
	RCALL SUBOPT_0x1B
; 0000 00E0 if(!a2){  lcd_gotoxy(11,0); dd_lcd(" ",5);}
_0x55:
	SBRC R2,4
	RJMP _0x56
	LDI  R30,LOW(11)
	RCALL SUBOPT_0x16
	RCALL _lcd_gotoxy
	__POINTW1FN _0x0,231
	RCALL SUBOPT_0xD
	LDI  R30,LOW(5)
	RCALL SUBOPT_0x1B
; 0000 00E1 
; 0000 00E2 break;
_0x56:
	RJMP _0x26
; 0000 00E3 //case 7:  //-------------------------------------------SOUND REZONATOR  ON/OFF---------------------//
; 0000 00E4 //my_keys();
; 0000 00E5 //lcd_gotoxy(0,0); dd_lcd("       " ,11);
; 0000 00E6 //lcd_gotoxy(0,1); dd_lcd("v   /   x" ,16);
; 0000 00E7 //if(ok){a3=1; PORTC.1=1;}
; 0000 00E8 //if(x){a3=0; PORTC.1=0;}
; 0000 00E9 //delay_ms(1);
; 0000 00EA //if(sec>=60){#asm("cli"); m_buffer=k; }  //anti kosac
; 0000 00EB //if(a3){   lcd_gotoxy(11,0); dd_lcd("  ",5); }
; 0000 00EC //if(!a3){  lcd_gotoxy(11,0); dd_lcd(" ",5);}
; 0000 00ED 
; 0000 00EE //if(j==20){delay_us(1); rf++; j=0;}   //  FOR ID RADIATION FON ID IS 15-25~=20;
; 0000 00EF //if(k>warn){delay_us(1); #asm("cli"); i=11; }   //to ALARM radiation
; 0000 00F0 //break;
; 0000 00F1 case 7:  //---------------------------------WARNING LEVEL------------MODE +/- --------------------------//
_0x4D:
	CPI  R30,LOW(0x7)
	LDI  R26,HIGH(0x7)
	CPC  R31,R26
	BRNE _0x57
; 0000 00F2 my_keys();
	RCALL _my_keys
; 0000 00F3 lcd_gotoxy(7,0);
	LDI  R30,LOW(7)
	RCALL SUBOPT_0x16
	RCALL SUBOPT_0x17
; 0000 00F4 sprintf(lcd_buffer,"=%3u ",warn);//
	__POINTW1FN _0x0,237
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0x2
	RCALL SUBOPT_0x18
	RCALL SUBOPT_0x27
; 0000 00F5 lcd_puts(lcd_buffer);
; 0000 00F6 lcd_gotoxy(0,0);
	RCALL SUBOPT_0xC
	RCALL _lcd_gotoxy
; 0000 00F7 dd_lcd("",7);
	__POINTW1FN _0x0,243
	RCALL SUBOPT_0xD
	LDI  R30,LOW(7)
	RCALL SUBOPT_0x24
; 0000 00F8 lcd_gotoxy(0,1); dd_lcd("+ <   > -",16);
	RCALL SUBOPT_0xE
	__POINTW1FN _0x0,251
	RCALL SUBOPT_0xF
	RCALL _dd_lcd
; 0000 00F9 lcd_gotoxy(12,0); dd_lcd(" ",4);
	LDI  R30,LOW(12)
	RCALL SUBOPT_0x16
	RCALL _lcd_gotoxy
	__POINTW1FN _0x0,268
	RCALL SUBOPT_0xD
	LDI  R30,LOW(4)
	RCALL SUBOPT_0x1B
; 0000 00FA if(sec>=60){#asm("cli"); m_buffer=k; }  //anti kosac
	RCALL SUBOPT_0x25
	BRLT _0x58
	cli
	RCALL SUBOPT_0x21
; 0000 00FB if(warn<400){if(!key1){warn++;   load1=warn; delay_ms(380);   }}
_0x58:
	RCALL SUBOPT_0x2A
	CPI  R26,LOW(0x190)
	LDI  R30,HIGH(0x190)
	CPC  R27,R30
	BRGE _0x59
	SBIC 0x16,1
	RJMP _0x5A
	RCALL SUBOPT_0x2B
	ADIW R30,1
	RCALL SUBOPT_0x2C
_0x5A:
; 0000 00FC if(warn>2){if(!key4){warn--;  load1=warn;  delay_ms(380);  }}
_0x59:
	RCALL SUBOPT_0x2A
	SBIW R26,3
	BRLT _0x5B
	SBIC 0x16,3
	RJMP _0x5C
	RCALL SUBOPT_0x2B
	SBIW R30,1
	RCALL SUBOPT_0x2C
_0x5C:
; 0000 00FD 
; 0000 00FE break;
_0x5B:
	RJMP _0x26
; 0000 00FF case 8:  //-------------------POWER--DOWN--MODE --------------------------//
_0x57:
	CPI  R30,LOW(0x8)
	LDI  R26,HIGH(0x8)
	CPC  R31,R26
	BRNE _0x5D
; 0000 0100 //#asm("cli");
; 0000 0101 my_keys();
	RCALL _my_keys
; 0000 0102 sec=0; //for 1 main menu
	RCALL SUBOPT_0x11
; 0000 0103 lcd_gotoxy(0,0); dd_lcd("     ",16);
	RCALL SUBOPT_0xC
	RCALL SUBOPT_0xC
	RCALL _lcd_gotoxy
	__POINTW1FN _0x0,273
	RCALL SUBOPT_0xF
	RCALL SUBOPT_0x13
; 0000 0104 lcd_gotoxy(0,1); dd_lcd("    <<   ",16);
	RCALL SUBOPT_0xE
	__POINTW1FN _0x0,290
	RCALL SUBOPT_0xF
	RCALL _dd_lcd
; 0000 0105 if(!key1){delay_ms(90); my_beep(); rf=0; j=0;    i=9;}// go to case9
	SBIC 0x16,1
	RJMP _0x5E
	LDI  R30,LOW(90)
	LDI  R31,HIGH(90)
	RCALL SUBOPT_0x8
	RCALL _my_beep
	RCALL SUBOPT_0x12
	RCALL SUBOPT_0x1
	LDI  R30,LOW(9)
	LDI  R31,HIGH(9)
	MOVW R12,R30
; 0000 0106 
; 0000 0107 break;
_0x5E:
	RJMP _0x26
; 0000 0108 case 9:  //-------------------POWER--DOWN--ON--------------------------//
_0x5D:
	CPI  R30,LOW(0x9)
	LDI  R26,HIGH(0x9)
	CPC  R31,R26
	BREQ PC+2
	RJMP _0x5F
; 0000 0109 #asm("cli");
	cli
; 0000 010A lcd_clear();
	RCALL _lcd_clear
; 0000 010B auto1=0;        //auto off
	CLT
	BLD  R2,2
; 0000 010C a1=0;      //start OFF
	BLD  R2,3
; 0000 010D a2=0;    // BACKLIGHT OFF
	BLD  R2,4
; 0000 010E //a3=0;    //SOUND REZONATOR  OFF
; 0000 010F a4=0;    //AUTO RESTART MODE OFF
	BLD  R2,5
; 0000 0110 //sound=0;   //off
; 0000 0111 light=0;     //off
	CBI  0x15,4
; 0000 0112 #asm("sei");  //Start
	sei
; 0000 0113 if(!key4){#asm("cli"); k=0; j=0; beep=0; sec=0; rf=0; i=8;}  //Stop   mode end EXIT
	SBIC 0x16,3
	RJMP _0x62
	cli
	RCALL SUBOPT_0x10
	CBI  0x15,5
	RCALL SUBOPT_0x11
	RCALL SUBOPT_0x12
	RCALL SUBOPT_0x9
	MOVW R12,R30
; 0000 0114 if(sec==60){sec=0; k=0; j=0; rf=0; } //auto restart mode:2
_0x62:
	RCALL SUBOPT_0x1F
	CP   R30,R6
	CPC  R31,R7
	BRNE _0x65
	RCALL SUBOPT_0x22
	RCALL SUBOPT_0x12
; 0000 0115 
; 0000 0116 if((sec==5)|(sec==15)|(sec==25)|(sec==35)|(sec==45)|(sec==55)){ b=0;}// off bloking
_0x65:
	MOVW R26,R6
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
	RCALL SUBOPT_0x2D
	LDI  R30,LOW(15)
	LDI  R31,HIGH(15)
	RCALL SUBOPT_0x2E
	LDI  R30,LOW(25)
	LDI  R31,HIGH(25)
	RCALL SUBOPT_0x2E
	LDI  R30,LOW(35)
	LDI  R31,HIGH(35)
	RCALL SUBOPT_0x2E
	LDI  R30,LOW(45)
	LDI  R31,HIGH(45)
	RCALL SUBOPT_0x2E
	LDI  R30,LOW(55)
	LDI  R31,HIGH(55)
	RCALL __EQW12
	RCALL SUBOPT_0x2F
	BREQ _0x66
	CBI  0x15,0
; 0000 0117 if((sec==0)|(sec==10)|(sec==20)|(sec==30)|(sec==40)|(sec==50)|(sec==59)){ b=1;}//on bloking
_0x66:
	MOVW R26,R6
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	RCALL SUBOPT_0x2D
	RCALL SUBOPT_0x3
	RCALL SUBOPT_0x2E
	LDI  R30,LOW(20)
	LDI  R31,HIGH(20)
	RCALL SUBOPT_0x2E
	LDI  R30,LOW(30)
	LDI  R31,HIGH(30)
	RCALL SUBOPT_0x2E
	LDI  R30,LOW(40)
	LDI  R31,HIGH(40)
	RCALL SUBOPT_0x2E
	RCALL SUBOPT_0x30
	RCALL SUBOPT_0x2F
	BREQ _0x69
	SBI  0x15,0
; 0000 0118 // to lcd markers  (is scan)
; 0000 0119 if((sec==10)|(sec==20)|(sec==30)|(sec==40)|(sec==50)|(sec==59)){
_0x69:
	MOVW R26,R6
	RCALL SUBOPT_0x3
	RCALL SUBOPT_0x2D
	LDI  R30,LOW(20)
	LDI  R31,HIGH(20)
	RCALL SUBOPT_0x2E
	LDI  R30,LOW(30)
	LDI  R31,HIGH(30)
	RCALL SUBOPT_0x2E
	LDI  R30,LOW(40)
	LDI  R31,HIGH(40)
	RCALL SUBOPT_0x2E
	RCALL SUBOPT_0x30
	RCALL SUBOPT_0x2F
	BRNE PC+2
	RJMP _0x6C
; 0000 011A delay_ms(160);
	RCALL SUBOPT_0x31
; 0000 011B lcd_gotoxy(0,0); lcd_putsf("");
	RCALL SUBOPT_0xC
	RCALL SUBOPT_0xC
	RCALL SUBOPT_0x32
; 0000 011C lcd_gotoxy(0,1); dd_lcd("....",16);
	RCALL SUBOPT_0xC
	RCALL SUBOPT_0xE
	__POINTW1FN _0x0,309
	RCALL SUBOPT_0xF
	RCALL _dd_lcd
; 0000 011D delay_ms(160);
	RCALL SUBOPT_0x31
; 0000 011E lcd_gotoxy(1,0); lcd_putsf("");
	LDI  R30,LOW(1)
	RCALL SUBOPT_0x16
	RCALL SUBOPT_0x32
; 0000 011F delay_ms(160);
	RCALL SUBOPT_0x31
; 0000 0120 lcd_gotoxy(2,0); lcd_putsf("");
	LDI  R30,LOW(2)
	RCALL SUBOPT_0x16
	RCALL SUBOPT_0x32
; 0000 0121 delay_ms(160);
	RCALL SUBOPT_0x31
; 0000 0122 lcd_gotoxy(3,0); lcd_putsf("");
	LDI  R30,LOW(3)
	RCALL SUBOPT_0x16
	RCALL SUBOPT_0x32
; 0000 0123 delay_ms(160);
	RCALL SUBOPT_0x31
; 0000 0124 lcd_gotoxy(4,0); lcd_putsf("");
	LDI  R30,LOW(4)
	RCALL SUBOPT_0x16
	RCALL SUBOPT_0x32
; 0000 0125 delay_ms(160);
	RCALL SUBOPT_0x31
; 0000 0126 lcd_gotoxy(5,0); lcd_putsf("");
	LDI  R30,LOW(5)
	RCALL SUBOPT_0x16
	RCALL SUBOPT_0x32
; 0000 0127 delay_ms(160);
	RCALL SUBOPT_0x31
; 0000 0128 lcd_gotoxy(6,0); lcd_putsf("");
	LDI  R30,LOW(6)
	RCALL SUBOPT_0x16
	RCALL SUBOPT_0x32
; 0000 0129 delay_ms(160);
	RCALL SUBOPT_0x31
; 0000 012A lcd_gotoxy(7,0); lcd_putsf("");
	LDI  R30,LOW(7)
	RCALL SUBOPT_0x16
	RCALL SUBOPT_0x32
; 0000 012B delay_ms(160);
	RCALL SUBOPT_0x31
; 0000 012C lcd_gotoxy(8,0); lcd_putsf("");
	LDI  R30,LOW(8)
	RCALL SUBOPT_0x16
	RCALL SUBOPT_0x32
; 0000 012D delay_ms(160);
	RCALL SUBOPT_0x31
; 0000 012E lcd_gotoxy(9,0); lcd_putsf("");
	LDI  R30,LOW(9)
	RCALL SUBOPT_0x16
	RCALL SUBOPT_0x32
; 0000 012F delay_ms(160);
	RCALL SUBOPT_0x31
; 0000 0130 lcd_gotoxy(10,0); lcd_putsf("");
	LDI  R30,LOW(10)
	RCALL SUBOPT_0x16
	RCALL SUBOPT_0x32
; 0000 0131 delay_ms(160);
	RCALL SUBOPT_0x31
; 0000 0132 lcd_gotoxy(11,0); lcd_putsf("");
	LDI  R30,LOW(11)
	RCALL SUBOPT_0x16
	RCALL SUBOPT_0x32
; 0000 0133 delay_ms(160);
	RCALL SUBOPT_0x31
; 0000 0134 lcd_gotoxy(12,0); lcd_putsf("");
	LDI  R30,LOW(12)
	RCALL SUBOPT_0x16
	RCALL SUBOPT_0x32
; 0000 0135 delay_ms(160);
	RCALL SUBOPT_0x31
; 0000 0136 lcd_gotoxy(13,0); lcd_putsf("");
	LDI  R30,LOW(13)
	RCALL SUBOPT_0x16
	RCALL SUBOPT_0x32
; 0000 0137 delay_ms(160);
	RCALL SUBOPT_0x31
; 0000 0138 lcd_gotoxy(14,0); lcd_putsf("");
	LDI  R30,LOW(14)
	RCALL SUBOPT_0x16
	RCALL SUBOPT_0x32
; 0000 0139 delay_ms(160);}
	RCALL SUBOPT_0x31
; 0000 013A break;
_0x6C:
	RJMP _0x26
; 0000 013B case 10:  //-------------------Alarm case --------------------------//
_0x5F:
	CPI  R30,LOW(0xA)
	LDI  R26,HIGH(0xA)
	CPC  R31,R26
	BRNE _0x26
; 0000 013C //my_keys();
; 0000 013D sec=0; //for 1 main menu
	RCALL SUBOPT_0x11
; 0000 013E beep=1;
	SBI  0x15,5
; 0000 013F lcd_gotoxy(0,0); dd_lcd("  ",16);
	RCALL SUBOPT_0xC
	RCALL SUBOPT_0xC
	RCALL _lcd_gotoxy
	__POINTW1FN _0x0,326
	RCALL SUBOPT_0xF
	RCALL SUBOPT_0x13
; 0000 0140 lcd_gotoxy(0,1); dd_lcd("!      ",16);
	RCALL SUBOPT_0xE
	__POINTW1FN _0x0,343
	RCALL SUBOPT_0xF
	RCALL SUBOPT_0x14
; 0000 0141 if((!key1)|(!key2)|(!key3)|(!key4)){delay_ms(90); my_beep(); beep=0; i=1;}// go to case1
	BREQ _0x70
	LDI  R30,LOW(90)
	LDI  R31,HIGH(90)
	RCALL SUBOPT_0x8
	RCALL _my_beep
	CBI  0x15,5
	RCALL SUBOPT_0x33
	MOVW R12,R30
; 0000 0142 delay_ms(200);
_0x70:
	LDI  R30,LOW(200)
	LDI  R31,HIGH(200)
	RCALL SUBOPT_0x7
; 0000 0143 beep=0;
; 0000 0144 break;
; 0000 0145 
; 0000 0146 }
_0x26:
; 0000 0147  };
	RJMP _0x21
; 0000 0148  }
_0x75:
	RJMP _0x75
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif

	.CSEG
_putchar:
     sbis usr,udre
     rjmp _putchar
     ld   r30,y
     out  udr,r30
	RJMP _0x2080001
__put_G100:
	RCALL __SAVELOCR2
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	RCALL __GETW1P
	SBIW R30,0
	BREQ _0x2000010
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	RCALL __GETW1P
	MOVW R16,R30
	SBIW R30,0
	BREQ _0x2000012
	__CPWRN 16,17,2
	BRLO _0x2000013
	MOVW R30,R16
	SBIW R30,1
	MOVW R16,R30
	ST   X+,R30
	ST   X,R31
_0x2000012:
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
	SBIW R30,1
	LDD  R26,Y+6
	STD  Z+0,R26
_0x2000013:
	RJMP _0x2000014
_0x2000010:
	LDD  R30,Y+6
	ST   -Y,R30
	RCALL _putchar
_0x2000014:
	RCALL __LOADLOCR2
	ADIW R28,7
	RET
__print_G100:
	SBIW R28,6
	RCALL __SAVELOCR6
	LDI  R17,0
_0x2000015:
	LDD  R30,Y+18
	LDD  R31,Y+18+1
	ADIW R30,1
	STD  Y+18,R30
	STD  Y+18+1,R31
	SBIW R30,1
	LPM  R30,Z
	MOV  R18,R30
	CPI  R30,0
	BRNE PC+2
	RJMP _0x2000017
	MOV  R30,R17
	RCALL SUBOPT_0x5
	SBIW R30,0
	BRNE _0x200001B
	CPI  R18,37
	BRNE _0x200001C
	LDI  R17,LOW(1)
	RJMP _0x200001D
_0x200001C:
	RCALL SUBOPT_0x34
_0x200001D:
	RJMP _0x200001A
_0x200001B:
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BRNE _0x200001E
	CPI  R18,37
	BRNE _0x200001F
	RCALL SUBOPT_0x34
	RJMP _0x20000BC
_0x200001F:
	LDI  R17,LOW(2)
	LDI  R20,LOW(0)
	LDI  R16,LOW(0)
	CPI  R18,45
	BRNE _0x2000020
	LDI  R16,LOW(1)
	RJMP _0x200001A
_0x2000020:
	CPI  R18,43
	BRNE _0x2000021
	LDI  R20,LOW(43)
	RJMP _0x200001A
_0x2000021:
	CPI  R18,32
	BRNE _0x2000022
	LDI  R20,LOW(32)
	RJMP _0x200001A
_0x2000022:
	RJMP _0x2000023
_0x200001E:
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BRNE _0x2000024
_0x2000023:
	LDI  R21,LOW(0)
	LDI  R17,LOW(3)
	CPI  R18,48
	BRNE _0x2000025
	RCALL SUBOPT_0x35
	LDI  R30,LOW(128)
	LDI  R31,HIGH(128)
	RCALL SUBOPT_0x36
	RJMP _0x200001A
_0x2000025:
	RJMP _0x2000026
_0x2000024:
	CPI  R30,LOW(0x3)
	LDI  R26,HIGH(0x3)
	CPC  R31,R26
	BREQ PC+2
	RJMP _0x200001A
_0x2000026:
	CPI  R18,48
	BRLO _0x2000029
	CPI  R18,58
	BRLO _0x200002A
_0x2000029:
	RJMP _0x2000028
_0x200002A:
	MOV  R26,R21
	RCALL SUBOPT_0x37
	RCALL SUBOPT_0x3
	MULS R30,R26
	MOVW R30,R0
	MOV  R21,R30
	MOV  R22,R21
	CLR  R23
	MOV  R26,R18
	RCALL SUBOPT_0x37
	LDI  R30,LOW(48)
	LDI  R31,HIGH(48)
	RCALL __SWAPW12
	SUB  R30,R26
	SBC  R31,R27
	MOVW R26,R22
	ADD  R30,R26
	MOV  R21,R30
	RJMP _0x200001A
_0x2000028:
	MOV  R30,R18
	RCALL SUBOPT_0x5
	CPI  R30,LOW(0x63)
	LDI  R26,HIGH(0x63)
	CPC  R31,R26
	BRNE _0x200002E
	RCALL SUBOPT_0x38
	RCALL SUBOPT_0x39
	RCALL SUBOPT_0x38
	LDD  R26,Z+4
	ST   -Y,R26
	RCALL SUBOPT_0x3A
	RJMP _0x200002F
_0x200002E:
	CPI  R30,LOW(0x73)
	LDI  R26,HIGH(0x73)
	CPC  R31,R26
	BRNE _0x2000031
	RCALL SUBOPT_0x3B
	RCALL SUBOPT_0x3C
	RCALL _strlen
	MOV  R17,R30
	RJMP _0x2000032
_0x2000031:
	CPI  R30,LOW(0x70)
	LDI  R26,HIGH(0x70)
	CPC  R31,R26
	BRNE _0x2000034
	RCALL SUBOPT_0x3B
	RCALL SUBOPT_0x3C
	RCALL _strlenf
	MOV  R17,R30
	RCALL SUBOPT_0x35
	RCALL SUBOPT_0x9
	RCALL SUBOPT_0x36
_0x2000032:
	RCALL SUBOPT_0x35
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	RCALL SUBOPT_0x36
	RCALL SUBOPT_0x35
	LDI  R30,LOW(65407)
	LDI  R31,HIGH(65407)
	RCALL SUBOPT_0x3D
	LDI  R19,LOW(0)
	RJMP _0x2000035
_0x2000034:
	CPI  R30,LOW(0x64)
	LDI  R26,HIGH(0x64)
	CPC  R31,R26
	BREQ _0x2000038
	CPI  R30,LOW(0x69)
	LDI  R26,HIGH(0x69)
	CPC  R31,R26
	BRNE _0x2000039
_0x2000038:
	RCALL SUBOPT_0x35
	RCALL SUBOPT_0x3E
	RCALL SUBOPT_0x36
	RJMP _0x200003A
_0x2000039:
	CPI  R30,LOW(0x75)
	LDI  R26,HIGH(0x75)
	CPC  R31,R26
	BRNE _0x200003B
_0x200003A:
	LDI  R30,LOW(_tbl10_G100*2)
	LDI  R31,HIGH(_tbl10_G100*2)
	RCALL SUBOPT_0x3F
	LDI  R17,LOW(5)
	RJMP _0x200003C
_0x200003B:
	CPI  R30,LOW(0x58)
	LDI  R26,HIGH(0x58)
	CPC  R31,R26
	BRNE _0x200003E
	RCALL SUBOPT_0x35
	RCALL SUBOPT_0x9
	RCALL SUBOPT_0x36
	RJMP _0x200003F
_0x200003E:
	CPI  R30,LOW(0x78)
	LDI  R26,HIGH(0x78)
	CPC  R31,R26
	BREQ PC+2
	RJMP _0x2000070
_0x200003F:
	LDI  R30,LOW(_tbl16_G100*2)
	LDI  R31,HIGH(_tbl16_G100*2)
	RCALL SUBOPT_0x3F
	LDI  R17,LOW(4)
_0x200003C:
	RCALL SUBOPT_0x35
	RCALL SUBOPT_0x40
	BREQ _0x2000041
	RCALL SUBOPT_0x3B
	RCALL SUBOPT_0x41
	LDD  R26,Y+11
	TST  R26
	BRPL _0x2000042
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	RCALL __ANEGW1
	STD  Y+10,R30
	STD  Y+10+1,R31
	LDI  R20,LOW(45)
_0x2000042:
	CPI  R20,0
	BREQ _0x2000043
	SUBI R17,-LOW(1)
	RJMP _0x2000044
_0x2000043:
	RCALL SUBOPT_0x35
	RCALL SUBOPT_0x42
_0x2000044:
	RJMP _0x2000045
_0x2000041:
	RCALL SUBOPT_0x3B
	RCALL SUBOPT_0x41
_0x2000045:
_0x2000035:
	RCALL SUBOPT_0x35
	RCALL SUBOPT_0x43
	BRNE _0x2000046
_0x2000047:
	CP   R17,R21
	BRSH _0x2000049
	RCALL SUBOPT_0x35
	RCALL SUBOPT_0x44
	BREQ _0x200004A
	RCALL SUBOPT_0x35
	RCALL SUBOPT_0x40
	BREQ _0x200004B
	RCALL SUBOPT_0x35
	RCALL SUBOPT_0x42
	MOV  R18,R20
	SUBI R17,LOW(1)
	RJMP _0x200004C
_0x200004B:
	LDI  R18,LOW(48)
_0x200004C:
	RJMP _0x200004D
_0x200004A:
	LDI  R18,LOW(32)
_0x200004D:
	RCALL SUBOPT_0x34
	SUBI R21,LOW(1)
	RJMP _0x2000047
_0x2000049:
_0x2000046:
	MOV  R19,R17
	RCALL SUBOPT_0x35
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	RCALL SUBOPT_0x45
	BREQ _0x200004E
_0x200004F:
	CPI  R19,0
	BREQ _0x2000051
	RCALL SUBOPT_0x35
	RCALL SUBOPT_0x9
	RCALL SUBOPT_0x45
	BREQ _0x2000052
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,1
	RCALL SUBOPT_0x3F
	SBIW R30,1
	LPM  R30,Z
	RJMP _0x20000BD
_0x2000052:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LD   R30,X+
	STD  Y+6,R26
	STD  Y+6+1,R27
_0x20000BD:
	ST   -Y,R30
	RCALL SUBOPT_0x3A
	CPI  R21,0
	BREQ _0x2000054
	SUBI R21,LOW(1)
_0x2000054:
	SUBI R19,LOW(1)
	RJMP _0x200004F
_0x2000051:
	RJMP _0x2000055
_0x200004E:
_0x2000057:
	LDI  R18,LOW(48)
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	RCALL __GETW1PF
	STD  Y+8,R30
	STD  Y+8+1,R31
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,2
	RCALL SUBOPT_0x3F
_0x2000059:
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	CP   R26,R30
	CPC  R27,R31
	BRLO _0x200005B
	SUBI R18,-LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	SUB  R30,R26
	SBC  R31,R27
	STD  Y+10,R30
	STD  Y+10+1,R31
	RJMP _0x2000059
_0x200005B:
	CPI  R18,58
	BRLO _0x200005C
	RCALL SUBOPT_0x35
	RCALL SUBOPT_0x9
	RCALL SUBOPT_0x45
	BREQ _0x200005D
	MOV  R30,R18
	RCALL SUBOPT_0x5
	ADIW R30,7
	RJMP _0x20000BE
_0x200005D:
	MOV  R30,R18
	RCALL SUBOPT_0x5
	ADIW R30,39
_0x20000BE:
	MOV  R18,R30
_0x200005C:
	RCALL SUBOPT_0x35
	LDI  R30,LOW(16)
	LDI  R31,HIGH(16)
	RCALL SUBOPT_0x45
	BRNE _0x2000060
	CPI  R18,49
	BRSH _0x2000062
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,1
	BRNE _0x2000061
_0x2000062:
	RJMP _0x20000BF
_0x2000061:
	CP   R21,R19
	BRLO _0x2000066
	RCALL SUBOPT_0x35
	RCALL SUBOPT_0x43
	BREQ _0x2000067
_0x2000066:
	RJMP _0x2000065
_0x2000067:
	LDI  R18,LOW(32)
	RCALL SUBOPT_0x35
	RCALL SUBOPT_0x44
	BREQ _0x2000068
	LDI  R18,LOW(48)
_0x20000BF:
	MOV  R26,R16
	RCALL SUBOPT_0x37
	LDI  R30,LOW(16)
	LDI  R31,HIGH(16)
	RCALL SUBOPT_0x36
	RCALL SUBOPT_0x35
	RCALL SUBOPT_0x40
	BREQ _0x2000069
	RCALL SUBOPT_0x35
	RCALL SUBOPT_0x42
	ST   -Y,R20
	RCALL SUBOPT_0x3A
	CPI  R21,0
	BREQ _0x200006A
	SUBI R21,LOW(1)
_0x200006A:
_0x2000069:
_0x2000068:
_0x2000060:
	RCALL SUBOPT_0x34
	CPI  R21,0
	BREQ _0x200006B
	SUBI R21,LOW(1)
_0x200006B:
_0x2000065:
	SUBI R19,LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,2
	BRLO _0x2000058
	RJMP _0x2000057
_0x2000058:
_0x2000055:
	RCALL SUBOPT_0x35
	RCALL SUBOPT_0x43
	BREQ _0x200006C
_0x200006D:
	CPI  R21,0
	BREQ _0x200006F
	SUBI R21,LOW(1)
	LDI  R30,LOW(32)
	ST   -Y,R30
	RCALL SUBOPT_0x3A
	RJMP _0x200006D
_0x200006F:
_0x200006C:
_0x2000070:
_0x200002F:
_0x20000BC:
	LDI  R17,LOW(0)
_0x200001A:
	RJMP _0x2000015
_0x2000017:
	RCALL __LOADLOCR6
	ADIW R28,20
	RET
_sprintf:
	PUSH R15
	MOV  R15,R24
	SBIW R28,2
	RCALL __SAVELOCR2
	MOVW R26,R28
	RCALL __ADDW2R15
	MOVW R16,R26
	MOVW R26,R28
	ADIW R26,6
	RCALL __ADDW2R15
	RCALL __GETW1P
	STD  Y+2,R30
	STD  Y+2+1,R31
	MOVW R26,R28
	ADIW R26,4
	RCALL __ADDW2R15
	RCALL __GETW1P
	RCALL SUBOPT_0xD
	ST   -Y,R17
	ST   -Y,R16
	MOVW R30,R28
	ADIW R30,6
	RCALL SUBOPT_0xD
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	RCALL SUBOPT_0xD
	RCALL __print_G100
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	LDI  R30,LOW(0)
	ST   X,R30
	RCALL __LOADLOCR2
	ADIW R28,4
	POP  R15
	RET
    .equ __lcd_direction=__lcd_port-1
    .equ __lcd_pin=__lcd_port-2
    .equ __lcd_rs=0
    .equ __lcd_rd=1
    .equ __lcd_enable=2
    .equ __lcd_busy_flag=7

	.DSEG

	.CSEG
__lcd_delay_G101:
    ldi   r31,15
__lcd_delay0:
    dec   r31
    brne  __lcd_delay0
	RET
__lcd_ready:
    in    r26,__lcd_direction
    andi  r26,0xf                 ;set as input
    out   __lcd_direction,r26
    sbi   __lcd_port,__lcd_rd     ;RD=1
    cbi   __lcd_port,__lcd_rs     ;RS=0
__lcd_busy:
	RCALL __lcd_delay_G101
    sbi   __lcd_port,__lcd_enable ;EN=1
	RCALL __lcd_delay_G101
    in    r26,__lcd_pin
    cbi   __lcd_port,__lcd_enable ;EN=0
	RCALL __lcd_delay_G101
    sbi   __lcd_port,__lcd_enable ;EN=1
	RCALL __lcd_delay_G101
    cbi   __lcd_port,__lcd_enable ;EN=0
    sbrc  r26,__lcd_busy_flag
    rjmp  __lcd_busy
	RET
__lcd_write_nibble_G101:
    andi  r26,0xf0
    or    r26,r27
    out   __lcd_port,r26          ;write
    sbi   __lcd_port,__lcd_enable ;EN=1
	RCALL __lcd_delay_G101
    cbi   __lcd_port,__lcd_enable ;EN=0
	RCALL __lcd_delay_G101
	RET
__lcd_write_data:
    cbi  __lcd_port,__lcd_rd 	  ;RD=0
    in    r26,__lcd_direction
    ori   r26,0xf0 | (1<<__lcd_rs) | (1<<__lcd_rd) | (1<<__lcd_enable) ;set as output
    out   __lcd_direction,r26
    in    r27,__lcd_port
    andi  r27,0xf
    ld    r26,y
	RCALL __lcd_write_nibble_G101
    ld    r26,y
    swap  r26
	RCALL __lcd_write_nibble_G101
    sbi   __lcd_port,__lcd_rd     ;RD=1
	RJMP _0x2080001
__lcd_read_nibble_G101:
    sbi   __lcd_port,__lcd_enable ;EN=1
	RCALL __lcd_delay_G101
    in    r30,__lcd_pin           ;read
    cbi   __lcd_port,__lcd_enable ;EN=0
	RCALL __lcd_delay_G101
    andi  r30,0xf0
	RET
_lcd_read_byte0_G101:
	RCALL __lcd_delay_G101
	RCALL __lcd_read_nibble_G101
    mov   r26,r30
	RCALL __lcd_read_nibble_G101
    cbi   __lcd_port,__lcd_rd     ;RD=0
    swap  r30
    or    r30,r26
	RET
_lcd_gotoxy:
	RCALL __lcd_ready
	LD   R30,Y
	RCALL SUBOPT_0x5
	SUBI R30,LOW(-__base_y_G101)
	SBCI R31,HIGH(-__base_y_G101)
	LD   R30,Z
	RCALL SUBOPT_0x1D
	LDD  R30,Y+1
	RCALL SUBOPT_0x5
	ADD  R30,R26
	ADC  R31,R27
	RCALL SUBOPT_0x46
	LDD  R30,Y+1
	STS  __lcd_x,R30
	LD   R30,Y
	STS  __lcd_y,R30
	ADIW R28,2
	RET
_lcd_clear:
	RCALL __lcd_ready
	LDI  R30,LOW(2)
	RCALL SUBOPT_0x46
	RCALL __lcd_ready
	LDI  R30,LOW(12)
	RCALL SUBOPT_0x46
	RCALL __lcd_ready
	LDI  R30,LOW(1)
	RCALL SUBOPT_0x46
	LDI  R30,LOW(0)
	STS  __lcd_y,R30
	STS  __lcd_x,R30
	RET
_lcd_putchar:
    push r30
    push r31
    ld   r26,y
    set
    cpi  r26,10
    breq __lcd_putchar1
    clt
	LDS  R30,__lcd_x
	SUBI R30,-LOW(1)
	STS  __lcd_x,R30
	LDS  R30,__lcd_maxx
	LDS  R26,__lcd_x
	CP   R30,R26
	BRSH _0x2020004
	__lcd_putchar1:
	LDS  R30,__lcd_y
	SUBI R30,-LOW(1)
	STS  __lcd_y,R30
	RCALL SUBOPT_0xC
	LDS  R30,__lcd_y
	ST   -Y,R30
	RCALL _lcd_gotoxy
	brts __lcd_putchar0
_0x2020004:
    rcall __lcd_ready
    sbi  __lcd_port,__lcd_rs ;RS=1
    ld   r26,y
    st   -y,r26
    rcall __lcd_write_data
__lcd_putchar0:
    pop  r31
    pop  r30
	RJMP _0x2080001
_lcd_puts:
	ST   -Y,R17
_0x2020005:
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	LD   R30,X+
	STD  Y+1,R26
	STD  Y+1+1,R27
	MOV  R17,R30
	CPI  R30,0
	BREQ _0x2020007
	ST   -Y,R17
	RCALL _lcd_putchar
	RJMP _0x2020005
_0x2020007:
	RJMP _0x2080002
_lcd_putsf:
	ST   -Y,R17
_0x2020008:
	LDD  R30,Y+1
	LDD  R31,Y+1+1
	ADIW R30,1
	STD  Y+1,R30
	STD  Y+1+1,R31
	SBIW R30,1
	LPM  R30,Z
	MOV  R17,R30
	CPI  R30,0
	BREQ _0x202000A
	ST   -Y,R17
	RCALL _lcd_putchar
	RJMP _0x2020008
_0x202000A:
_0x2080002:
	LDD  R17,Y+0
	ADIW R28,3
	RET
__long_delay_G101:
    clr   r26
    clr   r27
__long_delay0:
    sbiw  r26,1         ;2 cycles
    brne  __long_delay0 ;2 cycles
	RET
__lcd_init_write_G101:
    cbi  __lcd_port,__lcd_rd 	  ;RD=0
    in    r26,__lcd_direction
    ori   r26,0xf7                ;set as output
    out   __lcd_direction,r26
    in    r27,__lcd_port
    andi  r27,0xf
    ld    r26,y
	RCALL __lcd_write_nibble_G101
    sbi   __lcd_port,__lcd_rd     ;RD=1
	RJMP _0x2080001
_lcd_init:
    cbi   __lcd_port,__lcd_enable ;EN=0
    cbi   __lcd_port,__lcd_rs     ;RS=0
	LD   R30,Y
	STS  __lcd_maxx,R30
	RCALL SUBOPT_0x5
	SUBI R30,LOW(-128)
	SBCI R31,HIGH(-128)
	__PUTB1MN __base_y_G101,2
	LD   R30,Y
	RCALL SUBOPT_0x5
	SUBI R30,LOW(-192)
	SBCI R31,HIGH(-192)
	__PUTB1MN __base_y_G101,3
	RCALL SUBOPT_0x47
	RCALL SUBOPT_0x47
	RCALL SUBOPT_0x47
	RCALL __long_delay_G101
	LDI  R30,LOW(32)
	ST   -Y,R30
	RCALL __lcd_init_write_G101
	RCALL __long_delay_G101
	LDI  R30,LOW(40)
	RCALL SUBOPT_0x46
	RCALL __long_delay_G101
	LDI  R30,LOW(4)
	RCALL SUBOPT_0x46
	RCALL __long_delay_G101
	LDI  R30,LOW(133)
	RCALL SUBOPT_0x46
	RCALL __long_delay_G101
    in    r26,__lcd_direction
    andi  r26,0xf                 ;set as input
    out   __lcd_direction,r26
    sbi   __lcd_port,__lcd_rd     ;RD=1
	RCALL _lcd_read_byte0_G101
	CPI  R30,LOW(0x5)
	BREQ _0x202000B
	LDI  R30,LOW(0)
	RJMP _0x2080001
_0x202000B:
	RCALL __lcd_ready
	LDI  R30,LOW(6)
	RCALL SUBOPT_0x46
	RCALL _lcd_clear
	LDI  R30,LOW(1)
_0x2080001:
	ADIW R28,1
	RET

	.CSEG

	.CSEG
_strlen:
    ld   r26,y+
    ld   r27,y+
    clr  r30
    clr  r31
strlen0:
    ld   r22,x+
    tst  r22
    breq strlen1
    adiw r30,1
    rjmp strlen0
strlen1:
    ret
_strlenf:
    clr  r26
    clr  r27
    ld   r30,y+
    ld   r31,y+
strlenf0:
    lpm  r0,z+
    tst  r0
    breq strlenf1
    adiw r26,1
    rjmp strlenf0
strlenf1:
    movw r30,r26
    ret

	.ESEG
_zone1:
	.DW  0x1
_zone2:
	.DW  0x1
_load1:
	.DW  0x4

	.DSEG
_m_buffer:
	.BYTE 0x2
_memory:
	.BYTE 0x2
_memory1:
	.BYTE 0x2
_warn:
	.BYTE 0x2
_lcd_buffer:
	.BYTE 0x7D
_kirilTable:
	.BYTE 0x40
__base_y_G101:
	.BYTE 0x4
__lcd_x:
	.BYTE 0x1
__lcd_y:
	.BYTE 0x1
__lcd_maxx:
	.BYTE 0x1
_p_S1030024:
	.BYTE 0x2

	.CSEG
;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x0:
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x1:
	CLR  R10
	CLR  R11
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x2:
	LDS  R30,_warn
	LDS  R31,_warn+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x3:
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x4:
	MOV  R30,R17
	LDD  R26,Y+3
	LDD  R27,Y+3+1
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 35 TIMES, CODE SIZE REDUCTION:66 WORDS
SUBOPT_0x5:
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x6:
	RCALL SUBOPT_0x3
	ST   -Y,R31
	ST   -Y,R30
	RJMP _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x7:
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
	CBI  0x15,5
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 32 TIMES, CODE SIZE REDUCTION:60 WORDS
SUBOPT_0x8:
	ST   -Y,R31
	ST   -Y,R30
	RJMP _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x9:
	LDI  R30,LOW(8)
	LDI  R31,HIGH(8)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0xA:
	MOVW R12,R30
	RCALL _my_beep
	LDI  R30,LOW(980)
	LDI  R31,HIGH(980)
	RJMP SUBOPT_0x8

;OPTIMIZER ADDED SUBROUTINE, CALLED 14 TIMES, CODE SIZE REDUCTION:11 WORDS
SUBOPT_0xB:
	LDI  R30,LOW(16)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 56 TIMES, CODE SIZE REDUCTION:53 WORDS
SUBOPT_0xC:
	LDI  R30,LOW(0)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 73 TIMES, CODE SIZE REDUCTION:70 WORDS
SUBOPT_0xD:
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES, CODE SIZE REDUCTION:16 WORDS
SUBOPT_0xE:
	LDI  R30,LOW(1)
	ST   -Y,R30
	RJMP _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 13 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0xF:
	RCALL SUBOPT_0xD
	RJMP SUBOPT_0xB

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:8 WORDS
SUBOPT_0x10:
	CLR  R4
	CLR  R5
	RJMP SUBOPT_0x1

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x11:
	CLR  R6
	CLR  R7
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x12:
	CLR  R8
	CLR  R9
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x13:
	RCALL _dd_lcd
	RJMP SUBOPT_0xC

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:15 WORDS
SUBOPT_0x14:
	RCALL _dd_lcd
	LDI  R26,0
	SBIS 0x16,1
	LDI  R26,1
	LDI  R30,0
	SBIS 0x16,4
	LDI  R30,1
	OR   R30,R26
	MOV  R26,R30
	LDI  R30,0
	SBIS 0x16,2
	LDI  R30,1
	OR   R30,R26
	MOV  R26,R30
	LDI  R30,0
	SBIS 0x16,3
	LDI  R30,1
	OR   R30,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x15:
	RCALL _my_beep
	LDI  R30,LOW(900)
	LDI  R31,HIGH(900)
	RJMP SUBOPT_0x8

;OPTIMIZER ADDED SUBROUTINE, CALLED 23 TIMES, CODE SIZE REDUCTION:20 WORDS
SUBOPT_0x16:
	ST   -Y,R30
	RJMP SUBOPT_0xC

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x17:
	RCALL _lcd_gotoxy
	LDI  R30,LOW(_lcd_buffer)
	LDI  R31,HIGH(_lcd_buffer)
	RJMP SUBOPT_0xD

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:8 WORDS
SUBOPT_0x18:
	RCALL __CWD1
	RCALL __PUTPARD1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x19:
	LDS  R30,_m_buffer
	LDS  R31,_m_buffer+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x1A:
	LDI  R30,LOW(_lcd_buffer)
	LDI  R31,HIGH(_lcd_buffer)
	RCALL SUBOPT_0xD
	RCALL _lcd_puts
	RJMP SUBOPT_0xC

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1B:
	ST   -Y,R30
	RJMP _dd_lcd

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x1C:
	LDI  R30,0
	SBRC R2,0
	LDI  R30,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1D:
	RCALL SUBOPT_0x5
	MOVW R26,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x1E:
	RCALL SUBOPT_0x5
	AND  R30,R26
	AND  R31,R27
	SBIW R30,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x1F:
	LDI  R30,LOW(60)
	LDI  R31,HIGH(60)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x20:
	CP   R6,R30
	CPC  R7,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x21:
	__PUTWMRN _m_buffer,0,4,5
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x22:
	RCALL SUBOPT_0x11
	RJMP SUBOPT_0x10

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x23:
	MOVW R26,R6
	LDI  R30,LOW(59)
	LDI  R31,HIGH(59)
	RCALL __EQW12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x24:
	ST   -Y,R30
	RJMP SUBOPT_0x13

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x25:
	RCALL SUBOPT_0x1F
	RJMP SUBOPT_0x20

;OPTIMIZER ADDED SUBROUTINE, CALLED 17 TIMES, CODE SIZE REDUCTION:14 WORDS
SUBOPT_0x26:
	RCALL SUBOPT_0xD
	RJMP _lcd_putsf

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x27:
	LDI  R24,4
	RCALL _sprintf
	ADIW R28,8
	RJMP SUBOPT_0x1A

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x28:
	RCALL _lcd_gotoxy
	__POINTW1FN _0x0,162
	RCALL SUBOPT_0xD
	LDI  R30,LOW(4)
	RJMP SUBOPT_0x24

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x29:
	MOV  R0,R30
	CLR  R1
	MOVW R26,R4
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
	RCALL __GEW12U
	RCALL SUBOPT_0x5
	AND  R30,R0
	AND  R31,R1
	SBIW R30,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x2A:
	LDS  R26,_warn
	LDS  R27,_warn+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x2B:
	LDI  R26,LOW(_warn)
	LDI  R27,HIGH(_warn)
	LD   R30,X+
	LD   R31,X+
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x2C:
	ST   -X,R31
	ST   -X,R30
	RCALL SUBOPT_0x2
	LDI  R26,LOW(_load1)
	LDI  R27,HIGH(_load1)
	RCALL __EEPROMWRW
	LDI  R30,LOW(380)
	LDI  R31,HIGH(380)
	RJMP SUBOPT_0x8

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x2D:
	RCALL __EQW12
	MOV  R0,R30
	CLR  R1
	MOVW R26,R6
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 11 TIMES, CODE SIZE REDUCTION:38 WORDS
SUBOPT_0x2E:
	RCALL __EQW12
	RCALL SUBOPT_0x5
	__ORWRR 0,1,30,31
	MOVW R26,R6
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x2F:
	RCALL SUBOPT_0x5
	OR   R30,R0
	OR   R31,R1
	SBIW R30,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x30:
	LDI  R30,LOW(50)
	LDI  R31,HIGH(50)
	RCALL __EQW12
	RCALL SUBOPT_0x5
	__ORWRR 0,1,30,31
	RJMP SUBOPT_0x23

;OPTIMIZER ADDED SUBROUTINE, CALLED 16 TIMES, CODE SIZE REDUCTION:28 WORDS
SUBOPT_0x31:
	LDI  R30,LOW(160)
	LDI  R31,HIGH(160)
	RJMP SUBOPT_0x8

;OPTIMIZER ADDED SUBROUTINE, CALLED 15 TIMES, CODE SIZE REDUCTION:40 WORDS
SUBOPT_0x32:
	RCALL _lcd_gotoxy
	__POINTW1FN _0x0,307
	RJMP SUBOPT_0x26

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x33:
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:19 WORDS
SUBOPT_0x34:
	ST   -Y,R18
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	RCALL SUBOPT_0xD
	MOVW R30,R28
	ADIW R30,15
	RCALL SUBOPT_0xD
	RJMP __put_G100

;OPTIMIZER ADDED SUBROUTINE, CALLED 21 TIMES, CODE SIZE REDUCTION:58 WORDS
SUBOPT_0x35:
	MOV  R26,R16
	LDI  R27,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x36:
	OR   R30,R26
	MOV  R16,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x37:
	LDI  R27,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x38:
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x39:
	SBIW R30,4
	STD  Y+16,R30
	STD  Y+16+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:16 WORDS
SUBOPT_0x3A:
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	RCALL SUBOPT_0xD
	MOVW R30,R28
	ADIW R30,15
	RCALL SUBOPT_0xD
	RJMP __put_G100

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x3B:
	RCALL SUBOPT_0x38
	RJMP SUBOPT_0x39

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x3C:
	LDD  R26,Y+16
	LDD  R27,Y+16+1
	ADIW R26,4
	RCALL __GETW1P
	STD  Y+6,R30
	STD  Y+6+1,R31
	RJMP SUBOPT_0xD

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x3D:
	AND  R30,R26
	MOV  R16,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x3E:
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x3F:
	STD  Y+6,R30
	STD  Y+6+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x40:
	RCALL SUBOPT_0x3E
	AND  R30,R26
	AND  R31,R27
	SBIW R30,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x41:
	LDD  R26,Y+16
	LDD  R27,Y+16+1
	ADIW R26,4
	RCALL __GETW1P
	STD  Y+10,R30
	STD  Y+10+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x42:
	LDI  R30,LOW(65531)
	LDI  R31,HIGH(65531)
	RJMP SUBOPT_0x3D

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x43:
	RCALL SUBOPT_0x33
	AND  R30,R26
	AND  R31,R27
	SBIW R30,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x44:
	LDI  R30,LOW(128)
	LDI  R31,HIGH(128)
	AND  R30,R26
	AND  R31,R27
	SBIW R30,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x45:
	AND  R30,R26
	AND  R31,R27
	SBIW R30,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x46:
	ST   -Y,R30
	RJMP __lcd_write_data

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x47:
	RCALL __long_delay_G101
	LDI  R30,LOW(48)
	ST   -Y,R30
	RJMP __lcd_init_write_G101


	.CSEG
_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x1F4
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__ADDW2R15:
	CLR  R0
	ADD  R26,R15
	ADC  R27,R0
	RET

__ANEGW1:
	NEG  R31
	NEG  R30
	SBCI R31,0
	RET

__CWD1:
	MOV  R22,R31
	ADD  R22,R22
	SBC  R22,R22
	MOV  R23,R22
	RET

__EQW12:
	CP   R30,R26
	CPC  R31,R27
	LDI  R30,1
	BREQ __EQW12T
	CLR  R30
__EQW12T:
	RET

__GEW12U:
	CP   R26,R30
	CPC  R27,R31
	LDI  R30,1
	BRSH __GEW12UT
	CLR  R30
__GEW12UT:
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

__GETW1PF:
	LPM  R0,Z+
	LPM  R31,Z
	MOV  R30,R0
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__SWAPW12:
	MOV  R1,R27
	MOV  R27,R31
	MOV  R31,R1

__SWAPB12:
	MOV  R1,R26
	MOV  R26,R30
	MOV  R30,R1
	RET

__EEPROMRDW:
	ADIW R26,1
	RCALL __EEPROMRDB
	MOV  R31,R30
	SBIW R26,1

__EEPROMRDB:
	SBIC EECR,EEWE
	RJMP __EEPROMRDB
	PUSH R31
	IN   R31,SREG
	CLI
	OUT  EEARL,R26
	OUT  EEARH,R27
	SBI  EECR,EERE
	IN   R30,EEDR
	OUT  SREG,R31
	POP  R31
	RET

__EEPROMWRW:
	RCALL __EEPROMWRB
	ADIW R26,1
	PUSH R30
	MOV  R30,R31
	RCALL __EEPROMWRB
	POP  R30
	SBIW R26,1
	RET

__EEPROMWRB:
	SBIS EECR,EEWE
	RJMP __EEPROMWRB1
	WDR
	RJMP __EEPROMWRB
__EEPROMWRB1:
	IN   R25,SREG
	CLI
	OUT  EEARL,R26
	OUT  EEARH,R27
	SBI  EECR,EERE
	IN   R24,EEDR
	CP   R30,R24
	BREQ __EEPROMWRB0
	OUT  EEDR,R30
	SBI  EECR,EEMWE
	SBI  EECR,EEWE
__EEPROMWRB0:
	OUT  SREG,R25
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

;END OF CODE MARKER
__END_OF_CODE:
